#include "centiped.h"

int centiped_level_data[] = {
//   cl, cs, lf, ls, lm, sf, ss, sm, ff, fs,
 12,  3,  6,  1,  1, 80,  3,  1, 80,  1,
 12,  3,  6,  1,  1, 70,  3,  1, 80,  1,
 12,  3,  6,  1,  1, 60,  3,  1, 80,  1,
 14,  3,  6,  1,  1, 60,  3,  1, 80,  1,
 14,  3,  6,  1,  1, 50,  2,  1, 80,  1,
 14,  3,  6,  1,  1, 50,  2,  2, 70,  1,
 16,  3,  6,  1,  1, 50,  2,  2, 70,  1,
 16,  3,  6,  1,  1, 40,  2,  2, 70,  1,
 16,  2,  5,  1,  1, 40,  2,  2, 70,  1,
 18,  2,  5,  1,  1, 40,  2,  2, 70,  1,
 18,  2,  5,  1,  1, 30,  2,  2, 60,  1,
 18,  2,  5,  1,  1, 30,  2,  2, 60,  1,
 18,  2,  5,  1,  1, 30,  2,  2, 60,  1,
 18,  2,  5,  1,  1, 20,  2,  2, 60,  2,
 18,  2,  5,  1,  1, 20,  2,  2, 50,  2,
 18,  2,  5,  1,  1, 20,  1,  2, 50,  2,
 18,  1,  4,  2,  1, 10,  1,  2, 50,  2,
 20,  1,  4,  2,  1, 10,  1,  2, 50,  2,
 20,  1,  4,  2,  1, 10,  1,  3, 40,  2,
 20,  1,  4,  2,  1,  1,  1,  3, 40,  2};

void centiped::level_defaults(int cl)
    {
    int tl=20;//centiped_level_data.length/total_vars;
    if (cl>=tl) cl=tl-1;

    CVAR_centipede_length=centiped_level_data[cl*total_vars+ 0];  // more is longer
    CVAR_cetniped_speed  =centiped_level_data[cl*total_vars+ 1];  // higher is slower
    CVAR_laser_freq      =centiped_level_data[cl*total_vars+ 2]; // higher is less freq
    CVAR_laser_speed     =centiped_level_data[cl*total_vars+ 3]; // higher is faster
    CVAR_laser_max       =centiped_level_data[cl*total_vars+ 4];  // higher is more laser shots
    CVAR_spider_freq     =centiped_level_data[cl*total_vars+ 5]; // higher is less freq
    CVAR_spider_speed    =centiped_level_data[cl*total_vars+ 6]; // higher is slower
    CVAR_spider_max      =centiped_level_data[cl*total_vars+ 7]; // higher is more spiders
    CVAR_faller_freq     =centiped_level_data[cl*total_vars+ 8]; // higher is less freq
    CVAR_faller_speed    =centiped_level_data[cl*total_vars+ 9]; // higher is faster
    }
        



void  centiped::next_turn()
    {
    int x,y,i,j;
    int n;
    int nx,ny;
    int b;
   
    int q;
    tnum++;

    if (special==1)
        {
        special=0;
        newgame(cur_level+1);
        }


    i=0;
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
                apfld[i++]=232323;
                else
                apfld[i++]=playfield->get(x,y);

    if ((rand()%CVAR_faller_freq)==0)
        {
        playfield->set(1+rand()%(MX-2),1,((rand()%top_rustic->total_players)<<4)+FALLER);
        fallsnd.play();
        }

    int spider_counter=0;

    for (b=0; b<CVAR_faller_speed; b++)
    for (y=MY-1; y>0; y--)
        for (x=1; x<MX-1; x++)
            {
            i=playfield->get(x,y);
            if ((i&0xf)==FALLER | (i&0xf)==(FALLER+1))
                {
                playfield->set(x,y,(rand()%5)==0?((i&0xf0)+SHROOM):BKGR);

                if (y!=(MY-2))
                    {
                    n=playfield->get(x,y+1);
                    if ((n&0xf)==BLAST)
                        {
                        score_enemy(i,n);
                        i++;
                        if ((i&0xf)!=(FALLER+1)) i=BKGR;
                        }
                    if ((n&0xf)==CENT_LEFT | (n&0xf)==CENT_RIGHT)
                        i=n;
                    playfield->set(x,y+1,i);
                    }
                }
            }


    if ((tnum%CVAR_spider_speed)==0)
    for (y=MY-1; y>0; y--)
        for (x=1; x<MX-1; x++)
            {
            i=playfield->get(x,y);
            if ((i&0xf)==SPIDER & playfield->a_get(x,y)==0)
                {
                nx=x-1+(((i&0x100)>>8)*2);
                ny=y-1+((rand()%2)*2);
                if (ny<(MY-(MY/4))) ny+=2;
                if (ny>(MY-2)) ny-=2;

                n=playfield->get(nx,ny);
                if ((n&0xf)==BLAST)
                    {
                    score_enemy(i,n);
                    i=BKGR;
                    }
                if (nx==0 | nx==(MX-1))
                    playfield->set(x,y,BKGR);
                    else
                    {
                    if ((n&0xf)==BKGR | i==BKGR)
                        {
                        playfield->set(nx,ny,i);
                        playfield->set(x,y,BKGR);
                        }
                        else
                        playfield->set(x,y,i^0x100);
                    }
                }
            }

    spider_counter=0;
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if ((playfield->get(x,y)&0xf)==SPIDER) spider_counter++;

    if (spider_counter<CVAR_spider_max)
    if ((rand()%CVAR_spider_freq)==0)
        {
        n=rand()%2;
        playfield->set(1+(n)*(MX-3),MY-(MY/4),((rand()%top_rustic->total_players)<<4)+SPIDER+((1-n)<<8));
        }

    for (b=0; b<CVAR_laser_speed; b++)
    for (y=1; y<MY-1; y++)
        for (x=1; x<MX-1; x++)
            {
            i=playfield->get(x,y);
            if ((i&0xf)==BLAST)
                {
                if (y>1)
                    {
                    n=playfield->get(x,y-1);
                    switch(n&0xf)
                        {
                        case CENT_LEFT:
                        case CENT_RIGHT:
                                        score_enemy(n,i); 
                                        i=(i&0xf0)+SHROOM;
                                        break;
                        case SPIDER:
                        case FALLER+1:
                        case SHROOM+2:
                                        score_enemy(n,i);
                                        i=BKGR;
                                        break;
                        case FALLER:
                        case SHROOM+1:
                        case SHROOM:
                                        score_enemy(n,i);
                                        i=n+1;
                                        break;
                        }
                    playfield->set(x,y-1,i);
                    }
                playfield->set(x,y,BKGR);
                }
            }


    if ((tnum%CVAR_cetniped_speed)==0)
        {
        for (y=MY-2; y>0; y--)
            for (j=0; j<2; j++)
                for (x=((1-j)*MX); x!=(j*MX); x+=(-1+(j*2)))
                    { // 0 left 1 right
                    if (playfield->a_get(x,y)==0)
                        {
                        i=playfield->get(x,y);
                        if ((i&0xf)==((j==0)?CENT_RIGHT:CENT_LEFT))
                            {
                            if ((playfield->get(x+(1-(j*2)),y)&0xf)==BKGR | (playfield->get(x+(1-(j*2)),y)&0xf)==BLAST)
                                {
                                n=playfield->get(x+(1-(j*2)),y);
                                if ((n&0xf)==BLAST)
                                    {
                                    score_enemy(i,n);
                                    i=(n&0xf0)+SHROOM;
                                    }
                                playfield->set(x+(1-(j*2)),y,i);
                                playfield->set(x,y,BKGR);
                                }
                                else
                                {
                                i=(i&0xf0)+((i&0xf)==CENT_LEFT?CENT_RIGHT:CENT_LEFT);
                                if (y!=(MY-2))
                                    {
                                    n=playfield->get(x,y+1);
                                    if ((n&0xf)==BLAST)
                                        {
                                        score_enemy(i,n);
                                        i=(n&0xf0)+SHROOM;
                                        }
                                    playfield->set(x,y+1,i);
                                    }
                                    else
                                    {
                                    for (q=0; q<top_rustic->total_players; q++)
                                        kill_player(q);
                                    }
                                playfield->set(x,y,BKGR);
                                }
                            }
                        }
                    }
        }

    for (x=1; x<(MX-2); x++)    //no shrooms on the bottom level.
        {
        n=playfield->get(x,MY-2);
        switch (n&0xf)
            {
            case SHROOM:
            case SHROOM+1:
            case SHROOM+2:
                n=BKGR; break;
            }
        if (playfield->get(x,MY-2)!=n)
            playfield->set(x,MY-2,n);
        }

    i=0;
    j=0;
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            {
            n=playfield->get(x,y);
            if (apfld[i++]==playfield->get(x,y))
                playfield->a_set(x,y,0);
            n=n&0xf;
            if (n==CENT_LEFT | n==CENT_RIGHT)
                j++;
            }

    if (j==0) newgame(cur_level+1);

    n=0;
    j=0;
    for (i=0; i<top_rustic->total_players; i++)
        {
        n+=top_rustic->players[i]->lives;
        if (top_rustic->players[i]->alive!=0)
            {
            move_player(i);
            j=1;
            }
        }
    if (j==0)
        if (n==0)
            alive=0;
            else
            newgame(cur_level);




    i=0;
    }

void centiped::score_enemy(int en, int bl)
    {
    int val=0;
    switch((en&0xf))
        {
        case SPIDER: val=120; break;
        case FALLER: val=150; break;
        case FALLER+1: val=300; break;
        case CENT_LEFT:
        case CENT_RIGHT: val=100; break;
        case SHROOM: val=5; break;
        case SHROOM+1: val=10; break;
        case SHROOM+2: val=15; break;
        }
//    top_rustic->players[((en&0xf0)>>4)].score+=val;
    top_rustic->players[((bl&0xf0)>>4)]->score+=val;

    switch((en&0xf))
        {
        case SPIDER:
        case FALLER+1:
        case CENT_LEFT:
        case CENT_RIGHT:
            livehit.play();
            break;
        
        case SHROOM:
        case SHROOM+1:
        case SHROOM+2:
        case FALLER:
            deadhit.play();
        }
    }


int centiped::game_resize_pictures()
    {
    int x,y;

    int i;

    PX=game_x/MX;
    PY=game_y/MY;
    if (PX<1 | PY<1) return(-1);

    pictures->resize(PX,PY);

    for (i=0; i<top_rustic->total_players; i++)
        {
        int mx,my;
        int p=pictures->lookup['a'+PLAYER];
        mx=pictures->myimages[p]->data[0];
        my=pictures->myimages[p]->data[1];
        int t=(mx*my*4)+2;
        int j;
        int q;
        for (j=0; j<t; j++)
            {
            q=pictures->myimages[p]->data[j];
            if (q==1) q=top_rustic->players[i]->color;
            pictures->myimages[pictures->lookup['0'+i]]->data[j]=q;
            }
        }

    playfield->all_on();

    ginit=1;
    return(1);
    }

centiped::centiped(rustic *r)
    : game (r)
    {
    gamename="Centipede";
    playfield = new pfield(MX,MY);
    tnum=0;
    pictures=new graflib("centiped.grf");
    livehit.load("bang.wav");//=top_rustic->rustic_getAudioClip("bang.au");
    deadhit.load("tick.wav");//=top_rustic->rustic_getAudioClip("tick.au");
    fallsnd.load("bloop.wav");//=top_rustic->rustic_getAudioClip("bloop.au");
    death.load("scream.wav");//=top_rustic->rustic_getAudioClip("scream.au");
    refresh_rate=.05f;
    top_rustic->key_form=top_rustic->LET_GO;
    cur_level=0;
    newgame(0);
    }

centiped::~centiped()
    {
    delete playfield;
    delete pictures;
    }

void centiped::newgame(int level)
    {
    int i,x,y;

  //  int ord[top_rustic->total_players];
    cur_level=level;
    level_defaults(cur_level);
    int sx,sy;
    sx=1;
    sy=2;

    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            {
            playfield->set(x,y,0xf0 + BLOCK);
            }
    for (y=1; y<MY-1; y++)
        for (x=1; x<MX-1; x++)
            playfield->set(x,y,0 + BKGR);
    for (i=0; i<30; i++)
        {
        x=1+rand()%(MX-2);
        y=1+rand()%(MY-2);
        playfield->set(x,y,((rand()%top_rustic->total_players)<<4)+SHROOM);
        }

    int dir=(rand()%2)==0?CENT_LEFT:CENT_RIGHT;
    for (x=0; x<CVAR_centipede_length; x++)
        playfield->set(x+1,1,+dir);


    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {
        top_rustic->players[i]->x=((MX/8)+(MX/4*i)); 
        top_rustic->players[i]->y=(MY-2);

        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->j=0;
        top_rustic->players[i]->r=0;
        }

    alive=1;
    char s[80];
    sprintf(s,"Round %d",cur_level+1);
    pause(s);
    }



int centiped::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;
    int n,clr,plr;

    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {
            n=playfield->get(x,y);
            clr=n&0xf;
            plr=(n&0xf0)>>4;

            switch (clr)
                {
                case BKGR:
                case BLOCK:
                    g->fillrect(plr,x*PX,y*PY,PX,PY);
                    break;
                case BLAST:
                    g->fillrect(14,x*PX+PX/2-1,y*PY,PX/4,PY);
                    break;
                case CENT_LEFT:
                case CENT_RIGHT:
                case SHROOM:
                case SHROOM+1:
                case SHROOM+2:
                case SPIDER:
                case FALLER:
                case FALLER+1:
                    g->domvid(pictures->image('a'+clr),x*PX,y*PY);
                    break;
                }

            playfield->a_set(x,y,0);
            c++;
            }

    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->alive==1)
                {
                g->domvid(pictures->image('0'+i),
                    top_rustic->players[i]->x*PX,
                    top_rustic->players[i]->y*PY);
                c++;
                }
    }

    if (c!=0)
        return(1);

    return(0);
    }




void centiped::move_player(int p)
    {
    int x=top_rustic->players[p]->x;
    int y=top_rustic->players[p]->y;
    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;





    check(p);
    key_check(p);
    check(p);

    int j;

    if (x!=top_rustic->players[p]->x | y!=top_rustic->players[p]->y)
        {
        for (j=0; j<top_rustic->total_players; j++)
            top_rustic->players[j]->moved=1;

        playfield->set(x,y,playfield->get(x,y));
        }
}


int centiped::count_shots(int p)
{
int x,y;
int c=0,n;
for (y=0; y<MY; y++)
    for (x=0; x<MX; x++)
        {
        n=playfield->get(x,y);
        if ((n&0xf)==BLAST & ((n&0xf0)>>4)==p)
            c++;
        }
return(c);
}

int centiped::total_live_players()
{
int i,j;
j=0;
for (i=0; i<top_rustic->total_players; i++)
    if (top_rustic->players[i]->alive==1) j++;
return(j);
}

void centiped::key_check(int p)
  {
  int x=top_rustic->players[p]->x;
  int y=top_rustic->players[p]->y;
  int j=top_rustic->players[p]->j;
  int r=top_rustic->players[p]->r;
  int jl=top_rustic->players[p]->jl;


  int i;

  int k;
  k=-1;

    int b;

if (j>0)
    j--;

if (top_rustic->players[p]->direction[top_rustic->players[p]->UP]==1)
    {
    if (count_shots(p)<CVAR_laser_max & top_rustic->players[p]->j==0)
        {
        if ((playfield->get(x,y)&0xf)!=BLOCK)
            {
            playfield->set(x,y,(p<<4)+BLAST);
            j=CVAR_laser_freq*total_live_players();
            //top_rustic->total_players;
            }
        }
    }

if (top_rustic->players[p]->direction[top_rustic->players[p]->RIGHT]==1)
    {
    b=playfield->get(x+1,y)&0xf;
    if (b==BKGR | b==CENT_LEFT | b==CENT_RIGHT)
        x=x+1;
    }

if (top_rustic->players[p]->direction[top_rustic->players[p]->LEFT]==1)
    {
    b=playfield->get(x-1,y)&0xf;
    if (b==BKGR | b==CENT_LEFT | b==CENT_RIGHT)
        x=x-1;
    }


  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->r=r;
  //return (0);
  }

void centiped::kill_player(int p)
{
if (top_rustic->players[p]->alive==1)
    {
    top_rustic->players[p]->alive=0;
    top_rustic->players[p]->lives--;
    death.play();
    }
}

void centiped::check(int p)
  {
  int x=top_rustic->players[p]->x;
  int y=top_rustic->players[p]->y;
  int j=top_rustic->players[p]->j;
  int r=top_rustic->players[p]->r;
  int jl=top_rustic->players[p]->jl;
  int score=top_rustic->players[p]->score;

  switch(playfield->get(x,y)&0xf)
{
case FALLER:
case FALLER+1:
case SPIDER:
case CENT_LEFT:
case CENT_RIGHT:  kill_player(p); break;
}

  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->r=r;
  top_rustic->players[p]->score=score;
  }


