#include "default.h"
#include "menu.h"

char *key_s[] = { "up","down","left","right" };

    void rusticdefaults::addline(char *s)
        {
        sprintf(output[needlines],s);
        needlines++;
        }

    rusticdefaults::rusticdefaults(rustic *r)
        : panel(PANEL_ENTIRE,PANEL_ENTIRE)
        {
        top_rustic=r;
        curline=0;
        needlines=0;
        doing=-1;
        addline("Rustic Defaults");
        addline("");
        addline("Number of Players:");
        myfont=new graffont(RUSTIC_FONT);
        myfont2=new graffont(RUSTIC_FONT);
        myfont2->fg=14;
        myfont2->bg=4;

        int i;
        for (i=0; i<MAX_PLAYERS; i++)
            newnames[i]=0;
        }

    rusticdefaults::~rusticdefaults()
        {
        delete myfont;
        int i;
        for (i=0; i<MAX_PLAYERS; i++)
            if (newnames[i]!=0) delete newnames[i];
        }

    void rusticdefaults::resize()
        {
        curline=0;
        fs=MY/RD_MAXLINES;
        fsx=MX/(strlen(output[2])+3); //num of players
        myfont->MX=fsx;
        myfont->MY=fs;
        myfont2->MX=fsx;
        myfont2->MY=fs;
        panel::resize();
        }

    int rusticdefaults::update(vid *onto)
        {
        int ret=0;
        if (curline<needlines) ret=1;
        int bg=1;
        int fg=15;
        if (curline==0)
            onto->fillrect(bg,0,0,MX,MY);

        while (curline<needlines)
            {
            myfont->print_text(onto,output[curline],0,fs*curline,fg,bg);
            curline++;
            }

        if ((doing%5)==0)
            if (newnames[doing/5]->require_focus==FOCUS_REJECTED)
                {
                newnames[doing/5]->require_focus=FOCUS_UNREQUIRED;
                focus=0;
                key(0);
                }

        return(ret+panel::update(onto));
        }

    void rusticdefaults::key(keyevent *e)
        {
        if (e!=0)
            panel::key(e);

        if ((doing%5)!=0 | e==0)
        {
        if (doing==-1)
            {
            int num=e->ch-'0';
            if (num<1) num=1;
            if (num>max_players) num=max_players;
            top_rustic->total_players=num;
            curline--;
            sprintf(output[curline],"%s %d",output[curline],num);
            doing++;
            }
            else
            {
            if ((doing%5)>0)
                {
                top_rustic->players[doing/5]->keys[(doing%5)-1]=e->k;
                doing++;
                }
            }

        if (e==0) doing++;

        if ((doing%5)==0 & doing!=(top_rustic->total_players*5))
            {
            addline("");
            char s[40];
            sprintf(s,"Player %d: ",(doing/5)+1);

            newnames[doing/5]=new edit_textbox(
                myfont2,top_rustic->players[doing/5]->name,
                6);

            add(newnames[doing/5],
                fsx*9,
                fs*needlines);
            focus=newnames[doing/5];

            addline(s);
            }

        if (doing==(top_rustic->total_players*5))
            {
            top_rustic->change_screen(new rusticmenu(top_rustic));
            }
            else
            {
            if ((doing%5)!=0)
                {
                char s[40];
                sprintf(s,"Press %s",key_s[(doing%5)-1]);
                addline(s);
                }
            }
        }
        }            
