#ifndef GAME_H
#define GAME_H

#ifndef PI
#define PI 3.141
#endif

#include "player.h"
#include "rustic.h"
#include "allegro.h"

class audioclip {
    public:
    SAMPLE *myclip;
    void load(char *f)
        {
        myclip=load_sample(f);
        }
    void play()
        {
        play_sample(myclip,255,127,1000,0);
        }
    void playfreq(int freq)
        {
        play_sample(myclip,255,127,freq,0);
        }
    ~audioclip()
        {
        destroy_sample(myclip);
        }
    };

class game : public component
    {
    public:

    MIDI *mymidi;

    static const int ESC_GAME=-1;

    int ginit;
    rustic *top_rustic;
    char *gamename;
    int savescores;

    int alive;
    int paused;
    float refresh_rate;
    int changes;
    int special;

    int first_frame;

    static const int default_screen_y=300;
    static const int default_font_size=12;
    static const int default_pause_font_size=15;
    int font_size;//=default_font_size;
    int pause_font_size;//=default_pause_font_size;
    int font_size_x;//=default_font_size;
    int pause_font_size_x;//=default_pause_font_size;

    sfont *score_font;//=new Font(font_name,Font.PLAIN,font_size);
    sfont *pause_font;//=new Font(font_name,Font.PLAIN,pause_font_size);

    int game_x;//=-1;
    int game_y;//=-1;

    int drawing_stuff;


    mvid *pausevid;

    int cur_frame;


    game(rustic *r);

    virtual ~game();
    virtual void next_turn() {}
  //  virtual void game_paint(vid *g);
    virtual int game_update(vid *g) {}
    virtual int game_resize_pictures() {}

    char pause_reason[80];//="";

    int pause_fa,pause_fd;
    int pause_width;
        
    void center_draw(sfont *f, vid *g, char *s, int y);
    int show_pause(vid *g);
    int show_scores(vid *g);
    int update(vid *myvid);

    void resize();
    void pause(char *reason);

    void unpause();
    void start_game();

    void key(keyevent *e);

    mvid *makeimage(unsigned char *img, int px, int py);
    };

#endif
