#include "../gui/classes.h"
#include "graflib.h"
#include "allegro.h"

#define GRAF_LOAD 1
#define GRAF_SAVE 2
#define GRAF_NAME 3
#define GRAF_CHANGESIZE 4
#define GRAF_QUIT 5
#define GRAF_DIGGER 6

menuitem menudata[] = {
"File",0,
"Name", GRAF_NAME,
"Load",GRAF_LOAD,
"Save",GRAF_SAVE,
"Quit",GRAF_QUIT,
"Load Digger BMPS",GRAF_DIGGER,
"^",0,
"Sizing",0,
"Change",GRAF_CHANGESIZE,
"^",0,
"^",0 };

class grafeditor : public dbuff_component
    {
    public:
    int gX,gY;
    graflib *mygraflib;
    unsigned char cur;
    unsigned char curch;
    unsigned char fg,bg;
    unsigned char ctype;

    int omx,omy,omb;
    int changes;
    int bs;
    int cbs;

    grafeditor()
        : dbuff_component(PANEL_ENTIRE,PANEL_ENTIRE)
        {
        gX=8;
        gY=8;
        mygraflib=new graflib(gX,gY);
        cur=0;
        changes=1;
        omx=0;omy=0;omb=0;
        curch=32;
        fg=15;
        bg=0;
        bs=0;cbs=0;
        }

    void resize()
        {
        changes=1;
        cbs=MX/17;

        bs=(MY-cbs)/gY;
        int b2=(MX/2)/gX;
        if (b2<bs) bs=b2;
        }

    void key(keyevent *e)
        {
        curch=e->ch;
        cur=mygraflib->lookup[curch];
        changes=1;
        }

    void mouse(mouseevent *e)
        {
        int x,y;

        x=e->x;
        y=e->y;
        if (y>(MY-cbs))
            {
            if (e->b==1)
                fg=x/cbs;
            if (e->b==2)
                bg=x/cbs;
            }


        if (e->b!=0)
            {
            int i;
            if (e->b==3)
                for (i=2; i<(2+(gX*gY*4)); i++)
                    mygraflib->myimages[cur]->data[i]=fg;

            int im=50;
            if (omb==0) im=1;
            int ox,oy;
            for (i=0; i<im; i++)
                {
                ox=(omx*i+(e->x*(im-i)))/im;
                oy=(omy*i+(e->y*(im-i)))/im;
                x=ox/bs;

                y=oy/bs;
                int xp,yp;
                xp=ox%bs;
                yp=oy%bs;

                if (x<gX & y<gY)
                {
                int ca=0;
                if ((((bs-1)-xp)*bs)<(yp*bs))
                    ca|=1;
                if ((xp*bs)<(yp*bs))
                    ca|=2;
                int d=2+((x+(y*gX))*BYTES_PER_BLOCK);
                if (e->b==1)
                    mygraflib->myimages[cur]->data[d+ca]=fg;
                if (e->b==2)
                    mygraflib->myimages[cur]->data[d+ca]=bg;
                //printf("drawn to sufarce..\n");
                changes=1;
                }
                }
            }

        omx=e->x;
        omy=e->y;
        omb=e->b;
        }

    int update()
        {
        int ret=changes;
        if (changes!=0)
            {
            myvid->clearvid();

            sfont mine(8);
            char s[80];
            sprintf(s," %c %d ",(char)curch,(int)cur);
            mine.print_text(myvid,s,MX/2,MY/2);

            mygraflib->resize(bs*gX,bs*gY);
            myvid->domvid(mygraflib->image(curch),0,0);
            mygraflib->resize(gX*4,gY*4);
            myvid->domvid(mygraflib->image(curch),MX/2,0);
            int x,y,m;
            int gridc=8;
            m=(gX)*bs;
            for (y=0; y<=gY; y++)
                myvid->line(gridc,0,y*bs,m,y*bs);
            m=(gY)*bs;
            for (x=0; x<=gX; x++)
                myvid->line(gridc,x*bs,0,x*bs,m);
            for (x=0; x<=16; x++)
                myvid->fillrect(x,x*cbs,MY-cbs,cbs-1,cbs-1);
            }
        changes=0;
        return(ret);
        }

    ~grafeditor()
        {
        delete mygraflib;
        }
    };

#define GSBOXW 3
class gsizechanger : public panel
    {
    public:
    sfont *myfont;
    edit_numberbox *mx;
    edit_numberbox *my;
    grafeditor *mygfe;

    gsizechanger(sfont *f, grafeditor *e)
        : panel(GSBOXW*f->MX,2*f->MY)
        {
        myfont=f;
        mygfe=e;

        mx=new edit_numberbox(f,&mygfe->gX,GSBOXW);
        my=new edit_numberbox(f,&mygfe->gY,GSBOXW);

        add(mx,0,0);
        add(my,0,myfont->MY);
        }

    int update(vid *onto)
        {
        if (have_focus==FOCUS_HAVENOT)
            {
            mygfe->mygraflib->imageresize(mygfe->gX,mygfe->gY);
            mygfe->resize();
            remove_me=REMOVE_NOW;
            }
        return(panel::update(onto));
        }

    ~gsizechanger()
        {
        delete mx;
        delete my;
        }
    };

void fixupgraf(unsigned char *d, BITMAP *b)
    {
    int x,y,c;
    for (x=0; x<12; x++)
        for (y=0; y<12; y++)
            {
            c=getpixel(b,x,y);
            int dp=2;
            dp+=(x+y*12)*4;
            int j;
            for (j=0; j<4; j++)
                d[dp+j]=c;
            }
    }

void loaddiggerbmps(graflib *myg)
    {
    unsigned char c;
    char str[40];
    BITMAP *b;
    PALETTE p;
    for (c='a'; c<='z'; c++)
        {
        sprintf(str,"clet%c.bmp",c);
        b=load_bitmap(str,p);
        fixupgraf(myg->myimages[myg->lookup[c]]->data,b);
        destroy_bitmap(b);
        }
    for (c='0'; c<='9'; c++)
        {
        sprintf(str,"cnum%c.bmp",c);
        b=load_bitmap(str,p);
        fixupgraf(myg->myimages[myg->lookup[c]]->data,b);
        destroy_bitmap(b);
        }
    }

class grafedit : public panel, public action_listener
    {
    public:

    grafeditor *mygrafeditor;
    pulldown_menu *mymenu;
    sfont *myfont;
    char fname[80];

    popfocus_panel *fn_panel;
    edit_textbox *fn_edit;

    gsizechanger *gse;

    grafedit()
        : panel(PANEL_ENTIRE,PANEL_ENTIRE)
        {
        myfont=new sfont();
        mymenu = new pulldown_menu(myfont,this,menudata,this);
        add(mymenu,0,0);
        mygrafeditor=new grafeditor();
        add(mygrafeditor,0,myfont->MY);

        sprintf(fname,"untitled.grf");
        fn_edit=new edit_textbox(myfont,fname,20);
        fn_panel=new popfocus_panel(fn_edit->sMX,fn_edit->sMY);
        fn_panel->add(fn_edit,0,0);

        gse=new gsizechanger(myfont,mygrafeditor);
        }

    void action(int a)
        {
        focus=mygrafeditor;
        switch(a)
            {
            case GRAF_NAME:
                add(fn_panel,PANEL_CENTER);  
                break;
            case GRAF_SAVE:
                mygrafeditor->mygraflib->save(fname);
                break;
            case GRAF_LOAD:
                mygrafeditor->mygraflib->load(fname);
                mygrafeditor->gX=
                    mygrafeditor->mygraflib->myimages[0]->data[0];
                mygrafeditor->gY=
                    mygrafeditor->mygraflib->myimages[0]->data[1];
                mygrafeditor->resize();
                break;
            case GRAF_CHANGESIZE:
                add(gse,PANEL_CENTER);
                focus=gse;
                break;
            case GRAF_QUIT:
                remove_me=REMOVE_NOW;
                break;
            case GRAF_DIGGER:
                loaddiggerbmps(mygrafeditor->mygraflib);
                break;
            }
        mygrafeditor->changes=1;
        }

    ~grafedit()
        {
        delete gse;
        delete mymenu;
        delete myfont;
        delete mygrafeditor;
        }
    };


int main(int argc, char *argv[])
    {
    printf ("Welcome to the rustic graphics editor\nby phil hassey\n");
    topwindow *mywin = new topwindow(TOPWINDOW_MOUSE);

    mywin->mydvid->pal[16][0]=0xff;
    mywin->mydvid->pal[16][1]=0x33;
    mywin->mydvid->pal[16][2]=0x99;
    mywin->mydvid->showpal();

    grafedit *mygrafedit=new grafedit();
    if (argc==2)
    {
	    sprintf (mygrafedit->fname,"%s.grf",argv[1]);
	    mygrafedit->action(GRAF_LOAD);
    }
    mywin->add(mygrafedit,0,0);
    mywin->run();

    delete mywin;
    delete mygrafedit;

    return(0);
    }

END_OF_MAIN();

