#include "graflib.h"

#include <stdio.h>
#include <ctype.h>

grafimage::grafimage(unsigned char *d)
    {
    data=d;
    MX=1;MY=1;
    rendered=new mvid(1,1);
    }

void grafimage::resize(int mx, int my)
    {
    if (mx!=MX | my!=MY)
        {
        MX=mx;MY=my;
        rendered->resize(MX,MY);

        int w,h;
        unsigned char a,f,b;
        int x,y;
        int xx,yy;
        int mxx,myy;
        int c=0;

        w=data[c++];
        h=data[c++];

       // int ct,cl,cr,cb;
       int ca;

       unsigned char *m=rendered->getmpointer();

        for (y=0; y<h; y++)
            for (x=0; x<w; x++)
                {
                /*
                ct=data[c++];
                cl=data[c++];
                cr=data[c++];
                cb=data[c++];
                */

                int cx,cy;
                cx=(((x)*MX)/w);
                cy=(((y)*MY)/h);

                mxx=(((x+1)*MX)/w) - (((x)*MX)/w);
                myy=(((y+1)*MY)/h) - (((y)*MY)/h);
                for (xx=0; xx<mxx; xx++)
                    for (yy=0; yy<myy; yy++)
                        {
                        ca=0;
                        if ((((mxx-1)-xx)*myy)<(yy*mxx))
                            ca|=1;
                        if ((xx*myy)<(yy*mxx))
                            ca|=2;
			//rendered->dopixel(data[c+ca],cx+xx,cy+yy);
			m[(cx+xx)+((cy+yy)*MX)]=data[c+ca];
                        }
                c+=4;
                }
        }
    }

grafimage::~grafimage()
    {
    delete rendered;
    }

extern void decode_rcomp(FILE *from, unsigned char *to, long len);
extern void encode_rcomp(unsigned char *from,FILE *to, long len);

void graflib::load(char *fname)
    {
    FILE *stream;
    stream=fopen(fname,"rb");
    int i;
    for (i=0; i<GRAF_LIBSIZE; i++)
        {
        int x,y;
        x=fgetc(stream);
        y=fgetc(stream);
        int d;
        d=x*y*BYTES_PER_BLOCK;
        d+=2;
        if (myimages[i]->data != 0)
            delete [] myimages[i]->data;
        myimages[i]->data=new unsigned char[d];
        d-=2;
        myimages[i]->data[0]=x;
        myimages[i]->data[1]=y;
        //fread(myimages[i]->data+2,1,d,stream);
        decode_rcomp(stream,myimages[i]->data+2,d);
        myimages[i]->resize(1,1);
        }
    fclose(stream);
    }

void graflib::save(char *fname)
    {
    FILE *stream;
    stream=fopen(fname,"wb");
    int i;
    for (i=0; i<GRAF_LIBSIZE; i++)
        {
        int d;
        d=
        myimages[i]->data[0]*
        myimages[i]->data[1]*BYTES_PER_BLOCK ;
      //  d+=2;
      //  fwrite(myimages[i]->data,1,d,stream);
        fputc(myimages[i]->data[0],stream);
        fputc(myimages[i]->data[1],stream);
        encode_rcomp(myimages[i]->data+2,stream,d);
        }
    fclose(stream);
    }

void graflib::make_lookup()
    {
    char *graf_refs = " abcdefghijklmnopqrstuvwxyz0123456789)!@#$%^&*(-=_+[]\\{}|;':\",./<>?`~";
    int i;
    for (i=0; i<256; i++)
        lookup[i]=0;
    for (i=0; i<GRAF_LIBSIZE; i++)
        {
        lookup[graf_refs[i]]=i;
        lookup[toupper(graf_refs[i])]=i;
        }
    }


graflib::graflib(int mx, int my)
    {
    int i=(mx*my*BYTES_PER_BLOCK)+2;
    int j;
    make_lookup();
    for (j=0; j<GRAF_LIBSIZE; j++)
        myimages[j]=new grafimage(0);
    imageresize(mx,my);
    }

graflib::graflib(char *fname)
    {
    int j;
    make_lookup();
    for (j=0; j<GRAF_LIBSIZE; j++)
        myimages[j]=new grafimage(0);

    load(fname);
    }

void graflib::resize(int mx, int my)
    {
    dMX=mx;
    dMY=my;
    }

void graflib::imageresize(int mx, int my)
    {
    int i=(mx*my*BYTES_PER_BLOCK)+2;
    int j;
    if (mx!=dMX | my!=dMY)
    {
    for (j=0; j<GRAF_LIBSIZE; j++)
        {
        if (myimages[j]->data != 0)
            delete [] myimages[j]->data;
        myimages[j]->data=new unsigned char[i];

        int k;
        for (k=0;k<i; k++)
            myimages[j]->data[k]=0;

        myimages[j]->data[0]=mx;
        myimages[j]->data[1]=my;
        }
    dMX=mx;
    dMY=my;
    }
    }

mvid *graflib::image(unsigned char c)
    {
    int i=lookup[c];
    if (i<0 | i>=GRAF_LIBSIZE)
        printf (" Error : %d too big a image ref\n",i);
        else
        {
    myimages[i]->resize(dMX,dMY);
    return(myimages[i]->rendered);
    }
    }

mvid *graflib::imageint(int i)
    {
    if (i<0 | i>=GRAF_LIBSIZE)
        printf (" Error : %d too big a image ref\n",i);
        else
        {
        myimages[i]->resize(dMX,dMY);
        return(myimages[i]->rendered);
        }
    }

graflib::~graflib()
    {
    int j;
    for (j=0; j<GRAF_LIBSIZE; j++)
        {
        delete [] myimages[j]->data;
        delete myimages[j];
        }
    }


