#include "../gui/classes.h"
#include "graflib.h"
#include "levellib.h"
#include "allegro.h"

#define GRAF_LOAD 1
#define GRAF_NAME 2

#define LEVEL_LOAD 3
#define LEVEL_SAVE 4
#define LEVEL_NAME 5
#define LEVEL_CHANGESIZE 6
#define LEVEL_QUIT 7
#define LEVEL_JOESNOW 8

menuitem menudata[] = {
"File",0,
"GrafName", GRAF_NAME,
"GrafLoad",GRAF_LOAD,
"LevelName",LEVEL_NAME,
"LLoad",LEVEL_LOAD,
"LSave",LEVEL_SAVE,
"Quit",LEVEL_QUIT,
"Load Joesnow",LEVEL_JOESNOW,
"^",0,
"Sizing",0,
"LevelChange",LEVEL_CHANGESIZE,
"^",0,
"^",0 };

class leveleditor : public dbuff_component
    {
    public:
    graflib *mygraflib;
    int lX,lY;
    levellib *mylevellib;
    unsigned char cur;
    unsigned char curch;
    int fg,bg;
    int omx,omy,omb;
    int changes;
    int bs;
    int cbs;

    leveleditor()
        : dbuff_component(PANEL_ENTIRE,PANEL_ENTIRE)
        {
        mygraflib=new graflib(1,1);
        lX=40;
        lY=24;
        mylevellib=new levellib(lX,lY);

        cur=0;
        changes=1;
        omx=0;omy=0;omb=0;
        curch=32;
        fg=15;
        bg=0;
        bs=0;cbs=0;
        }

    void resize()
        {
        changes=2;
        cbs=(MX/(GRAF_LIBSIZE/2))*2;

        bs=(MY-cbs)/lY;
        int b2=MX/lX;
        if (b2<bs) bs=b2;
        }

    void key(keyevent *e)
        {
        curch=e->ch;
        cur=mylevellib->lookup[curch];
        mylevellib->mylevels[cur]->all_on();
        changes=1;
        }

    void mouse(mouseevent *e)
        {
        int x,y;

        x=e->x;
        y=e->y;
        int cbs2=cbs/2;
        if (y>(MY-cbs))
            {
            int ax,ay,an;
            ax=x/cbs2;
            ay=((y-(MY-cbs))/cbs2)*(GRAF_LIBSIZE/2);

            an=ax+ay;
            if (an<0) an=0;
            if (an>=GRAF_LIBSIZE) an=GRAF_LIBSIZE;

            if (e->b==1)
                fg=an;
            if (e->b==2)
                bg=an;
            }


        if (e->b!=0)
            {
            int i;
            int im=50;
            if (omb==0) im=1;
            int ox,oy;
            for (i=0; i<im; i++)
                {
                ox=(omx*i+(e->x*(im-i)))/im;
                oy=(omy*i+(e->y*(im-i)))/im;
                x=ox/bs;

                y=oy/bs;
                int xp,yp;
                xp=ox%bs;
                yp=oy%bs;

                if (x<lX & y<lY)
                {
                if (e->b==1)
                    mylevellib->mylevels[cur]->set(x,y,fg);
                if (e->b==2)
                    mylevellib->mylevels[cur]->set(x,y,bg);
                changes=1;
                }
                }
            }

        omx=e->x;
        omy=e->y;
        omb=e->b;
        }

    int update()
        {
        int ret=changes;
        if (changes!=0)
            {
            if (changes==2)
                 {
                 myvid->clearvid();
                 mylevellib->mylevels[cur]->all_on();
                 }

            sfont mine(8);
            char s[80];
            sprintf(s,"%c %2d %2d",(char)curch,(int)cur,(int)fg);
            mine.print_text(myvid,s,MX-(8*8),0);

            mygraflib->resize(bs,bs);
            int x,y,m;

            pfield *pf=mylevellib->mylevels[cur];
            for (y=0; y<lY; y++)
                for (x=0; x<lX; x++)
                    {
                    if (pf->a_get(x,y)!=0)
                        {
                        myvid->domvid(
                            mygraflib->imageint(pf->get(x,y)),
                            bs*x,bs*y);
                        pf->a_set(x,y,0);

                        int bkc=8;       
                        myvid->line(bkc,bs*x,bs*y,bs*x+bs,bs*y);
                        myvid->line(bkc,bs*x,bs*y,bs*x,bs*y+bs);
                        }
                    }

            if (changes==2)
            {
            int cbs2=cbs/2;
            mygraflib->resize(cbs2,cbs2);
            for (y=0; y<2; y++)
            for (x=0; x<GRAF_LIBSIZE/2; x++)
                {
                m=(y*(GRAF_LIBSIZE/2))+x;
                myvid->domvid(mygraflib->imageint(m),
                    x*cbs2,(MY-cbs)+(y*cbs2));
                }
            }
            }
        changes=0;
        return(ret);
        }

    ~leveleditor()
        {
        delete mylevellib;
        delete mygraflib;
        }
    };

#define GSBOXW 3
class lsizechanger : public panel
    {
    public:
    sfont *myfont;
    edit_numberbox *mx;
    edit_numberbox *my;
    leveleditor *mylfe;

    lsizechanger(sfont *f, leveleditor *e)
        : panel(GSBOXW*f->MX,2*f->MY)
        {
        myfont=f;
        mylfe=e;

        mx=new edit_numberbox(f,&mylfe->lX,GSBOXW);
        my=new edit_numberbox(f,&mylfe->lY,GSBOXW);

        add(mx,0,0);
        add(my,0,myfont->MY);
        }

    int update(vid *onto)
        {
        if (have_focus==FOCUS_HAVENOT)
            {
            mylfe->mylevellib->levelresize(mylfe->lX,mylfe->lY);
            mylfe->resize();
            remove_me=REMOVE_NOW;
            }
        return(panel::update(onto));
        }

    ~lsizechanger()
        {
        delete mx;
        delete my;
        }
    };


class leveledit : public panel, public action_listener
    {
    public:

    leveleditor *myleveleditor;
    pulldown_menu *mymenu;
    sfont *myfont;
    char fname[80];
    char lfname[80];

    popfocus_panel *fn_panel;
    edit_textbox *fn_edit;

    popfocus_panel *lfn_panel;
    edit_textbox *lfn_edit;

    lsizechanger *lse;

    leveledit()
        : panel(PANEL_ENTIRE,PANEL_ENTIRE)
        {
        myfont=new sfont();
        mymenu = new pulldown_menu(myfont,this,menudata,this);
        add(mymenu,0,0);
        myleveleditor=new leveleditor();
        add(myleveleditor,0,myfont->MY);

        sprintf(fname,"untitled.grf");
        fn_edit=new edit_textbox(myfont,fname,20);
        fn_panel=new popfocus_panel(fn_edit->sMX,fn_edit->sMY);
        fn_panel->add(fn_edit,0,0);

        sprintf(lfname,"untitled.lvl");
        lfn_edit=new edit_textbox(myfont,lfname,20);
        lfn_panel=new popfocus_panel(lfn_edit->sMX,lfn_edit->sMY);
        lfn_panel->add(lfn_edit,0,0);

        lse=new lsizechanger(myfont,myleveleditor);
        }

    void action(int a)
        {
        focus=myleveleditor;
        switch(a)
            {
            case GRAF_NAME:
                add(fn_panel,PANEL_CENTER);  
                break;
            case GRAF_LOAD:
                myleveleditor->mygraflib->load(fname);
                myleveleditor->resize();
                myleveleditor->changes=2;
                myleveleditor->update();
                break;
            case LEVEL_LOAD:
                myleveleditor->mylevellib->load(lfname);
                myleveleditor->lX=
                    myleveleditor->mylevellib->mylevels[0]->MX;
                myleveleditor->lY=
                    myleveleditor->mylevellib->mylevels[0]->MY;
                myleveleditor->resize();
                myleveleditor->changes=2;
                myleveleditor->update();
                break;
            case LEVEL_SAVE:
                myleveleditor->mylevellib->save(lfname);
                break;
            case LEVEL_NAME:
                add(lfn_panel,PANEL_CENTER);  
                break;
            case LEVEL_CHANGESIZE:
                add(lse,PANEL_CENTER);
                focus=lse;
                break;
            case LEVEL_QUIT:
                remove_me=REMOVE_NOW;
                break;
            case LEVEL_JOESNOW:
                //loaddiggerbmps(mygrafeditor->mygraflib);
                break;
            }
        myleveleditor->changes=1;
        }

    ~leveledit()
        {
        delete lse;
        delete mymenu;
        delete myfont;
        delete myleveleditor;
        }
    };


int main(int argc, char *argv[])
    {
    printf ("Welcome to the rustic level editor\nby phil hassey\n");
    topwindow *mywin = new topwindow(TOPWINDOW_MOUSE);

    leveledit *myleveledit=new leveledit();

    mywin->add(myleveledit,0,0);
	
	if (argc==2)
		{
		sprintf(myleveledit->fname,"%s.grf",argv[1]);
		sprintf(myleveledit->lfname,"%s.lvl",argv[1]);
		myleveledit->action(GRAF_LOAD);
		myleveledit->action(LEVEL_LOAD);
		}
		
    mywin->run();

    delete mywin;
    delete myleveledit;

    return(0);
    }

END_OF_MAIN();
