#include "classes.h"
#include "../vid/svid.h"

panel::panel(long smx, long smy)
    : component(smx,smy)
    {
    focus=0;
    total_components=0;
    panel_changes=1;
    omb=0;
    }

void panel::add(component *c, long spx, long spy)
    {
    int i;
    for (i=0; i<total_components; i++)
        if (components[i]==c) return;  //aready in there.

    if (total_components<MAX_COMPONENTS)
        {
        components[total_components]=c;
        components[total_components]->set_slocation(spx,spy);
        figure_out(components[total_components]);
        if (c->require_focus == FOCUS_REQUIRED) focus=c;
        if (total_components==0) focus=c;
        c->remove_me=REMOVE_NEVER;
        total_components++;
        panel_changes=1;
        }
    }

void panel::figure_out(component *c)
    {
    int mx,my,px,py;
    if (MX!=0 & MY!=0)
        {
        if ((c->sMX & PANEL_PERCENT)!=0)
            mx=(MX*(c->sMX&PANEL_POINTS))/100;
            else
            mx=c->sMX;

        if ((c->sMY & PANEL_PERCENT)!=0)
            my=(MY*(c->sMY&PANEL_POINTS))/100;
            else
            my=c->sMY;

        px=0;py=0;

        if ((c->sPX & PANEL_CENTER)!=0)
            px=(MX-mx)/2;

        if ((c->sPX & PANEL_PERCENT)!=0)
            px+=(MX*(c->sPX&PANEL_POINTS))/100;
            else
            px+=c->sPX&PANEL_POINTS;

        if ((c->sPY & PANEL_CENTER)!=0)
            py+=(MY-my)/2;

        if ((c->sPY & PANEL_PERCENT)!=0)
            py+=(MY*(c->sPY&PANEL_POINTS))/100;
            else
            py+=c->sPY&PANEL_POINTS;

        if ((px+mx)>MX)
            mx=MX-px;

        if ((py+my)>MY)
            my=MY-py;

        c->resize(mx,my);
        c->set_location(px,py);
        }
    }


#include <stdio.h>
void panel::add(component *c,long location)
    {
    if (location==PANEL_CENTER)
        add(c,PANEL_CENTER,PANEL_CENTER);
        else
        printf ("error positioning paenl \a");
    }

void panel::remove(component *c)
    {
    int i;
    int j=-1;
    for (i=0; i<total_components; i++)
        {
        if (c==components[i]) j=i;
        }
    if (j==-1) return;

    if (focus==c) focus=0;
    panel_changes=1;

    total_components--;
    for (i=j; i<total_components; i++)
        {
        components[j]=components[j+1];
        }
    }

int panel::update(vid *onto)
    {
    int i;
    int changes=panel_changes;
    panel_changes=0;
    svid *mysv = new svid(onto,0,0,0,0);

    for (i=0; i<total_components; i++)
        if (components[i]->remove_me==REMOVE_NOW)
            remove(components[i]);
    for (i=0; i<total_components; i++)
        if (components[i]==focus)
            components[i]->have_focus=FOCUS_HAVE;
            else
            components[i]->have_focus=FOCUS_HAVENOT;

    for (i=0; i<total_components; i++)
        {
        mysv->PX=components[i]->PX;
        mysv->PY=components[i]->PY;
        mysv->MX=components[i]->MX;
        mysv->MY=components[i]->MY;

        if (components[i]->require_focus==FOCUS_REQUIRED & focus!=components[i])
            {
            remove(components[i]);
            i--;
            }
            else
            {
            changes+=components[i]->update(mysv);
            if (components[i]->require_focus==FOCUS_REJECTED & focus==components[i])
                {
                int fc=i+1;
                if (fc==total_components) fc=0;
                components[i]->require_focus=FOCUS_UNREQUIRED;
                focus=components[fc];
                }
            }
        }

    delete mysv;
    return(changes);
    }

void panel::mouse(mouseevent *e)
    {
    int i;
    int mx,my;
    int x1,y1,x2,y2;
    mx=e->x;
    my=e->y;
    mouseevent *e2=new mouseevent(0,0,0);

    int hit=0;
    for (i=total_components-1; i>=0; i--)
        {
        x1=components[i]->PX;
        y1=components[i]->PY;
        x2=x1+components[i]->MX;
        y2=y1+components[i]->MY;
        if (mx>=x1 & mx<x2 & my>=y1 & my<y2 & focus==components[i])
            {
            hit=1;
            i=-1;
            }
            else
            if (e->b !=0 & e->b != omb & focus!=components[i])
                if (mx>=x1 & mx<x2 & my>=y1 & my<y2)
                    {
                    panel_changes=1;
                    focus=components[i];
                    i=-1;
                    hit=1;
                    }
        }
    if (hit==0 & e->b !=0 & e->b != omb) focus=0;


    for (i=total_components-1; i>=0; i--)
        {
        x1=components[i]->PX;
        y1=components[i]->PY;
        if (focus==components[i])
            {
            e2->x=mx-x1;
            e2->y=my-y1;
            e2->b=e->b;
            components[i]->mouse(e2);
            }
        }
                                                    
    omb=e->b;
    delete e2;
    }

void panel::key(keyevent *e)
    {
    if (focus != 0)
        focus->key(e);
    }

void panel::resize()
    {
    int i;
    for (i=0; i<total_components; i++)
        figure_out(components[i]);
    }

panel::~panel() {}

