#include "classes.h"
#include "allegro.h"
//#include "../settings.h"
#include "../vid/dvidw.h"

topwindow::topwindow(int params=0,int inwidth=0, int inheight=0)
    : panel(0,0)
    {
    myparams=params;

    if ((myparams&TOPWINDOW_NO_DBUFF)!=0)
        mydvid=new dvidw(DVIDW_DIRECT_WRITES|DVIDW_USE_ANYMODE,inwidth,inheight);
        else
        mydvid=new dvidw(0,inwidth,inheight);

    component::resize(mydvid->MX,mydvid->MY);

    install_timer();

    if ((myparams&TOPWINDOW_MOUSE)!=0)
        install_mouse();

    install_keyboard();

    int i,j;
    for (i=16; i<256; i++)
        {
        mydvid->pal[i][0]=255;
        mydvid->pal[i][1]=255;
        mydvid->pal[i][2]=255;
        }
    mydvid->pal[16][0]=0;
    mydvid->pal[16][1]=0;
    mydvid->pal[16][2]=0;

    mydvid->showpal();

    if ((myparams&TOPWINDOW_MOUSE)!=0)
        show_mouse(screen);

    #ifdef USE_SOUND
    install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,0);
    #endif
    }

//#include <conio.h>
void topwindow::run()
    {
    int capturenum=1;
    mouseevent *m=new mouseevent(mouse_x,mouse_y,mouse_b);
    keyevent *k=new keyevent(0,0,0);

    int ke;
    int me;
    int esc_quit=0;

    while (esc_quit==0 & total_components > 0)
        {
        while(keypressed())
            {
            int d=readkey();
            k->ch=d&0xff;
            k->k=(d&0x7f00)>>8;

            #ifdef SCREEN_CAPTURE
            if (k->ch=='\\')  // screen capture
                {
                PALLETE pallete;
                BITMAP *bitmap;

                bitmap=create_bitmap(MX,MY);
                int iy,ix;
                for (iy=0; iy<mydvid->MY; iy++)
                    for (ix=0; ix<mydvid->MX; ix++)
                        putpixel(bitmap,ix,iy,mydvid->getpixel(ix,iy));
                get_pallete(pallete);
                char fname[20];
                sprintf(fname,"picture%d.pcx",capturenum); capturenum++;
                save_pcx(fname,bitmap,pallete);
                destroy_bitmap(bitmap);
                }
            #endif

            key(k);
            }

        if ((myparams&TOPWINDOW_MOUSE)!=0)
            {
            if (mouse_x!=m->x | mouse_y != m->y | mouse_b != m->b)
                {
                m->x=mouse_x;
                m->y=mouse_y;
                m->b=mouse_b;
                mouse(m);
                }
            }

        if (update(mydvid)!=0)
            if ((myparams&TOPWINDOW_NO_DBUFF)==0)
	        {
		if ((myparams&TOPWINDOW_MOUSE)!=0) scare_mouse();
                mydvid->display_all();
		if ((myparams&TOPWINDOW_MOUSE)!=0) unscare_mouse();
                }
        
	#ifdef ESC_QUIT
        if (k->ch==27) esc_quit=1;
        #endif
        }
    delete k;
    delete m;
    }

topwindow::~topwindow()
    {
    if ((myparams&TOPWINDOW_MOUSE)!=0)
        remove_mouse();

    #ifdef USE_SOUND
    remove_sound();
    #endif

    remove_keyboard();

    remove_timer();

    delete mydvid;
    }
