#include "arkanoid.h"
#include <math.h>

#define PADDLE_THICK 2
#define PLAYER_SPEED 3

#define BALL_SPEED 3

#define MIN_BALL_SPEED 2
#define MAX_BALL_SPEED 6

#define MIN_LENGTH (PICX*2)
#define MAX_LENGTH (PICX*3)
#define BALL_SPEEDUP_TIME 1300

#define BALL_SCALE_DOWN 0.5
#define PADDLE_TOP_Y (SC_Y-(PICY*2))

//#include <io.h>
//int ark_lives;

int arkanoid_level_order[] = {
0,4,5,7,11,14,2,13,18,1,3,9,16,21,23,20,10,12,15,8,17,24,6,19,22 };

/*
void save_ark_lives(int l)
    {
    FILE *stream;
    stream=fopen("arkanoid.rec","ab");
    fputc(l,stream);
    fputc(ark_lives,stream);
    fclose(stream);
    }
int next_ark_rand()
    {
    unsigned char levels[25][2];
    FILE *stream;
    int j;
    long i,l;
    int c;

    for (i=0; i<25; i++)
        for (j=0; j<2; j++)
            levels[i][j]=0;

    stream=fopen("arkanoid.rec","rb");
    l=filelength(fileno(stream));
    l/=2;
    for (i=0; i<l; i++)
        {
        c=fgetc(stream);
        levels[c][0]++;
        levels[c][1]+=fgetc(stream);
        }
    fclose(stream);

    int n=5;
    i=0;
    while (n>=5)
        {
        i=rand()%25;
        n=levels[i][0];
        }
    return(i);
    }
*/

void arkanoid::next_turn()
    {
    int x,y,i,j;

    if (special==1)
        {
        special=0;
        newgame(cur_level+1);
        }

    if (special==2)
        {
        cheating=1;
        special=0;
        }


    i=0;

    int q;

    move_balls();

    if (pill.alive==1)
        {
        pill.y++;
        if (pill.y==(SC_Y-PICY))
            pill.alive=0;
        }

    for (j=0; j<top_rustic->total_players; j++)
        {
        if (top_rustic->players[j]->alive==1)
            {
            i++;
            move_player(j);
            }
        }

    int adlev=0;
    j=0;
    for (x=1; x<MX-1; x++)
        for (y=1; y<MY; y++)
            if (playfield->get(x,y)>0 & playfield->get(x,y)!=GOLD) j++;
    if (j==0) {adlev=1;i=0;}

    if (i==0)
        {
        x=0;
        for (j=0; j<top_rustic->total_players; j++)
            if (top_rustic->players[j]->lives>0)
                x+=top_rustic->players[j]->lives;                    
        if (x==0)
            alive=0;
            else
            {
            if (adlev != 0)
                {
           //     save_ark_lives(cur_level);
           //
           //     do  {
           //         adlev=next_ark_rand();
           //         }
           //         while (adlev == cur_level);
           //
                adlev=cur_level+1;
                newgame(adlev);
                }
                else
                newgame(cur_level);

            //newgame(cur_level+adlev);
            }
        }       
    }




int arkanoid::game_resize_pictures()
    {
    int x,y;

    int i;
    PX=game_x/screen_x;
    PY=game_y/screen_y;
    if (PX<1 | PY<1) return(-1);

    pictures->resize(PX,PY);

    playfield->all_on();
    ginit=1;
    return(1);
    }


arkanoid::arkanoid(rustic *r)
    : game(r)
    {
    gamename="Arkanoid";
    playfield = new pfield(MX,MY);
    playfield->defret=WALL;
    cplayfield = new pfield(MX,MY);
    cplayfield->defret=0;

    pictures = new graflib("arkanoid.grf");
    refresh_rate=0.018;//0.013;//0.0125;

    top_rustic->key_form=top_rustic->LET_GO;

    level_data = new levellib("arkanoid.lvl");

    cur_level=-1;

    death.load("scream.wav");
    bonus.load("doodle.wav");
    ticksound.load("tick.wav");
    smacksound.load("bang.wav");
//    beginlevel.load("arkanoid.wav");

    cheating=0;
    newgame(0);//next_ark_rand());
    }

arkanoid::~arkanoid()
    {
    delete playfield;
    delete cplayfield;
    delete level_data;
    delete pictures;
    }


void arkanoid::newgame(int level)
    {
    int i,x,y;
    
    int newlev=0;
    if (cur_level!=level) newlev=1;

    cur_level=level;


    int cur_screen;
        cur_screen=cur_level%different_levels;

    int gl=0;
    unsigned char c;

    if (newlev==1)
    {
//    ark_lives=0;
    for (y=0; y<MY-1; y++)
        for (x=0; x<MX-2; x++)
            {
            c=level_data->mylevels[arkanoid_level_order[cur_screen]]->get(x,y);
            playfield->set(x+1,y+1,c);
            if (c!=BKGR)
                cplayfield->set(x+1,y+1,cur_level/different_levels);
                else
                cplayfield->set(x+1,y+1,0);
            }

    int tt=27;
    for (x=1; x<MX-1; x++)
        playfield->set(x,0,tt+3);
    for (y=1; y<MY; y++)
        {
        playfield->set(0,y,tt+1);
        playfield->set(MX-1,y,tt+5);
        }
    playfield->set(0,0,tt+2);
    playfield->set(MX-1,0,tt+4);
    }

    int ord[MAX_PLAYERS];
    for (i=0; i<MAX_PLAYERS; i++) ord[i]=-1;
    x=0;
    while (x<MAX_PLAYERS)
        {
        y=rand()%MAX_PLAYERS;
        if (ord[y]==-1)
            {
            ord[y]=x;
            x++;
            }
        }



    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {
        top_rustic->players[i]->x=(SC_X*(i+1))/6;
        top_rustic->players[i]->y=PADDLE_TOP_Y+(PADDLE_THICK*ord[i]);

        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->len=PICX*2;
        }


    for (i=0; i<max_balls; i++)
        balls[i].alive=0;

    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->alive==1)
        {
        balls[i].x=top_rustic->players[i]->x;
        balls[i].y=top_rustic->players[i]->y;
        balls[i].alive=1;
        balls[i].t=0;
        balls[i].ax=cos(-PI/4);
        balls[i].ay=sin(-PI/4);
        balls[i].owner=i;
        balls[i].speed=BALL_SPEED;
        balls[i].noscores=0;
        }

    pill.alive=0;

    alive=1;
    char s[80];
    sprintf(s,"Level %d",cur_level+1);
    pause(s);
  //  beginlevel.play();
    }



int arkanoid::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;

    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {
            if (playfield->get(x,y)!=0)
                g->domvid(
                    pictures->imageint(playfield->get(x,y)),
                    (ADD_X+x)*PX,y*PY);
                else
                g->fillrect(0,(ADD_X+x)*PX,y*PY,PX,PY);
            playfield->a_set(x,y,0);
            c++;
            }

    g->fillrect(0,(ADD_X+1)*PX,PADDLE_TOP_Y*PY/PICY,
                  (MX-2)*PX,(PADDLE_THICK*(MAX_PLAYERS+1))*PY/PICY);
        
    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->alive==1)
                {
                top_rustic->players[i]->moved=0;

                g->fillrect(top_rustic->players[i]->color,
                    (ADD_X*PICX+top_rustic->players[i]->x)*PX/PICX,
                    top_rustic->players[i]->y*PY/PICY,
                    top_rustic->players[i]->len*PX/PICX,
                    PADDLE_THICK*PY/PICY);
                c++;
                }

    if (pill.alive!=0)
        {
        g->idomvid(pictures->imageint(PILL_IMG+pill.type),
            (ADD_X*PICX+pill.x)*PX/PICX,pill.y*PY/PICY);
        aset(pill.x,pill.y,PICX,PICY);
        }

    for (i=0; i<max_balls; i++)
        if (balls[i].alive==1)
            {
            int clr=15;
            if (balls[i].owner!=-1)
                clr=top_rustic->players[balls[i].owner]->color;

            int rady=5;
            g->fillrect(clr,
                (int)((ADD_X*PICX+balls[i].x-(rady/2))*PX/PICX),
                (int)((balls[i].y-(rady/2))*PY/PICY),
                (int)(rady*PX/PICX),
                (int)(rady*PY/PICY));

            aset((int)(balls[i].x-(rady/2))-1,(int)(balls[i].y-(rady/2))-1,
                rady+2,rady+2);
            }
    }

    if (c!=0)
        return(1);

    return(0);
    }

void arkanoid::aset(int x, int y, int mx, int my)
    {
    playfield->a_set((x+0)/PICX,(y+0)/PICY,1);
    playfield->a_set((x+0)/PICX,(y+my)/PICY,1);
    playfield->a_set((x+mx)/PICX,(y+0)/PICY,1);
    playfield->a_set((x+mx)/PICX,(y+my)/PICY,1);
    }

void arkanoid::move_player(int p)
    {
    int j;
    int x=top_rustic->players[p]->x;
    int y=top_rustic->players[p]->y;
    double mx=top_rustic->players[p]->dmx;

    int k;
    double a;
    int ia;
    int b=-1;
    for (j=0; j<max_balls; j++)
        if (balls[j].alive==1 & balls[j].owner==p)
            b=j;

    if (b==-1) kill_player(p);

    if ((pill.y+(PICY/2))==y & pill.alive==1)
        {
        if (x<=(pill.x+PICX) & (x+top_rustic->players[p]->len)>=pill.x)
            {
            bonus.play();
            top_rustic->players[p]->score+=35;
            switch(pill.type)
                {
                case PILL_SLOW:
                    for (j=0; j<max_balls; j++)
                        {
                        if (balls[j].owner==p)
                            {
                            balls[j].speed=MIN_BALL_SPEED;
                            balls[j].t=0;
                            }
                        }
                    break;
                case PILL_LASER:
                    break;
                case PILL_EXTEND:
                    top_rustic->players[p]->len=MAX_LENGTH;
                    break;
                case PILL_TRIPLE:
                    k=0;
                    for (j=0; j<max_balls; j++)
                        {
                        if (balls[j].alive==0)
                            {
                            ia=0;
                            while ((ia%8)==0)
                                ia=rand()%32;

                            a=(double)(ia)*PI/16.0;
                            balls[j].alive=1;
                            balls[j].t=0;
                            balls[j].x=balls[b].x;
                            balls[j].y=balls[b].y;
                            balls[j].ax=cos(a);
                            balls[j].ay=sin(a);
                            balls[j].owner=p;
                            balls[j].speed=balls[b].speed;
                            balls[j].noscores=0;
                            k++;
                            if (k==2) j=max_balls;
                            }
                        }
                    break;
                }
            }
        }

    x+=(int)(mx*(double)PLAYER_SPEED);
    if (x<PICX) x=PICX;
    if ((x+top_rustic->players[p]->len)>=((MX-1)*PICX))
        x=((MX-1)*PICX)-1-top_rustic->players[p]->len;

    top_rustic->players[p]->x=x;
    }


void arkanoid::kill_player(int p)
    {
    if (top_rustic->players[p]->alive!=0)
        {
       // ark_lives++;
        if (cheating)
            top_rustic->players[p]->score=0;
            else
            top_rustic->players[p]->lives--;
        top_rustic->players[p]->alive=0;
        death.play();
        }
    }


void arkanoid::bounce_ball(double ac, double as, double rc, double rs)
    {
    bb_rx=ac*(2*rc*rc-1)+2*as*rs*rc;
    bb_ry=2*ac*rs*rc+as*(1-2*rc*rc);
    }

/*
double arkanoid::FORCE_SIGN(double a,double b)
    {
    int flip=0;
    if (a<0 & b>0) flip=1;
    if (a>0 & b<0) flip=1;
    if (flip==1) return(-b);
    return(b);
    }
*/

#define FORCE_SIGN(a,b) ( ((a<0 & b>0)|(a>0 & b<0))?(-b):(b) )

void arkanoid::move_balls()
    {
    int b,i;
    double poss[6] = {
        -7*PI/8,-6*PI/8,
        -5*PI/8,-3*PI/8,
        -2*PI/8,-1*PI/8 };

    for (b=0; b<max_balls; b++)
    if (balls[b].alive==1)
    {
    balls[b].t++;
    if (balls[b].t==BALL_SPEEDUP_TIME)
        {
        balls[b].speed++;
        if (balls[b].speed>MAX_BALL_SPEED)
            balls[b].speed=MAX_BALL_SPEED;
        balls[b].t=0;
        }

    for (i=0; i<balls[b].speed; i++)
        {
        if (balls[b].alive==1)
            {
            double nx,ny;
            nx=balls[b].x+(balls[b].ax*BALL_SCALE_DOWN);
            ny=balls[b].y+(balls[b].ay*BALL_SCALE_DOWN);
            int x,y;
            x=(int)nx;
            y=(int)ny;

            unsigned char c;

            int dx,dy;
            dx=((x+PICX)/PICX)-1;
            dy=((y+PICY)/PICY)-1;
            c=playfield->get(dx,dy);

            if (c!=0)
                {
                int px,py;
                px=(x+PICX)%PICX;
                py=(y+PICY)%PICY;

                int er=0;
                if (px==0) er++;
                if (py==0) er++;
                if (px==(PICX-1)) er++;
                if (py==(PICY-1)) er++;

                int way=0;
                if (er==2)
                    {
                    // new code:

                    int corner_x=1;
                    int corner_y=1;
                    if (px==0) corner_x=-1;
                    if (py==0) corner_y=-1;

                    int way0=0;
                    int way1=0;

                    if (playfield->get(dx+corner_x,dy)!=0) way1=1;
                    if (playfield->get(dx,dy+corner_y)!=0) way0=1;

                    if (way1 == way0)
                        {
                        way=2;
                        bb_rx=FORCE_SIGN(corner_x,balls[b].ax);
                        bb_ry=FORCE_SIGN(corner_y,balls[b].ay);
                        }
                        else
                        {
                        if (way1>way0)
                            way=1;
                            else
                            way=0;
                        }

                    /* OLD CODE
                    int way1=0;
                    int way0=0;
                    if (playfield->get(dx-1,dy)!=0) way1++;
                    if (playfield->get(dx+1,dy)!=0) way1++;
                    if (playfield->get(dx,dy-1)!=0) way0++;
                    if (playfield->get(dx,dy+1)!=0) way0++;

                    if (way1>way0) way=1;
                    */
                    }
                    else
                    {
                    if (py==0 | py==(PICY-1))
                        way=1;
                    }

                if (way==1)
                    bounce_ball(balls[b].ax,balls[b].ay,1,0);

                if (way==0)
                    bounce_ball(balls[b].ax,balls[b].ay,0,1);

                balls[b].ax=bb_rx;
                balls[b].ay=bb_ry;

                balls[b].noscores++;
                if (balls[b].noscores==25)
                    {
                    bendangle(b,((double)(1+(rand()%2)))*PI/25);
                    balls[b].noscores=0;
                    }

                int smack=0;
                int rep=c;

                if (cplayfield->get(dx,dy)==0)
                    {
                    if (c!=0 & c<GOLD) {smack=1; rep=0;}
                    if (c==SILVER) {rep=CSILVER;}
                    if (c==CSILVER) {smack=1;rep=0;}
    
                    if (smack==1)
                        {
                        smacksound.play();
                        if (balls[b].owner!=-1)
                            {
                            top_rustic->players[balls[b].owner]->score+=10;
                            balls[b].noscores=0;
                            }
                        }
                        else
                        ticksound.play();
    
                    playfield->set(dx,dy,rep);
                    if (rep==0 & (rand()%5)==0)
                        {
                        if (pill.alive==0)
                            {
                            pill.alive=1;
                            pill.type=rand()%4;
                            if (pill.type==PILL_LASER)
                                pill.alive=0;
                            pill.x=dx*PICX;
                            pill.y=dy*PICY;
                            }
                        }
                    }
                    else
                    {
                    cplayfield->set(dx,dy,cplayfield->get(dx,dy)-1);
                    ticksound.play();
                    }
                }
                else
                {
                int bounce=0;

                double na;
                int p;
                for (p=0; p<top_rustic->total_players; p++)
                    if (
                        (y>=top_rustic->players[p]->y) &
                        (y<(top_rustic->players[p]->y+PADDLE_THICK))

                        )
                    {
                    if (top_rustic->players[p]->alive!=0)
                        {
                        if (x>=top_rustic->players[p]->x &
                            x<=(top_rustic->players[p]->x+
                                top_rustic->players[p]->len))
                            {
                            bounce=p+1;
                            na=
                             poss[(int)(
                             ((balls[b].x-top_rustic->players[p]->x)
                                *6)
                                /(top_rustic->players[p]->len+2))];
                            p=MAX_PLAYERS;

                            }
                        }
                    }
                if (bounce!=0)
                    {
                    changeangle(b,na);
                    balls[b].y-=PADDLE_THICK; // to make it not get stuck
                    ticksound.play();
                    top_rustic->players[bounce-1]->score+=3;
                   // balls[b].noscores=0;
                   //taken out because if you get caughtin a loop, you stillscore
                    }
                    else
                    {
                    balls[b].x=nx;
                    balls[b].y=ny;
                    }
                if (y==(PADDLE_TOP_Y+((MAX_PLAYERS+2)*PADDLE_THICK)))
                    {
                    if (balls[b].owner!=-1)
                        {
                        balls[b].alive=0;
                   //     kill_player(balls[b].owner);
                        }
                    }
                }
            }
        }
    }
    }



void arkanoid::bendangle(int b, double an)
    {
    double ca,sa;
    ca=cos(an);
    sa=sin(an);

    double nx,ny;
    double ox,oy;
    ox=balls[b].ax;
    oy=balls[b].ay;

    nx=ox*ca-oy*sa;
    ny=ox*sa+oy*ca;

    balls[b].ax=nx;
    balls[b].ay=ny;
    }

void arkanoid::changeangle(int b, double an)
    {
    double ca,sa;
    ca=cos(an);
    sa=sin(an);
    balls[b].ax=ca;
    balls[b].ay=sa;
    }




