#include "combat.h"
#include <math.h>


#define PLAYER_SPEED 2

#define NORM_BALL_SPEED 5
#define CLOSE_ENOUGH (PICX/2)

#define C_TSTART 65
#define C_PLETHAL (C_TSTART-3)

void combat::next_turn()
    {
    int x,y,i,j;

    if (special==1)
        {
        special=0;
        newgame(cur_level+1);
        }

    i=0;

    int q;

    move_balls();

    frame_num++;
    for (j=0; j<top_rustic->total_players; j++)
        {
        if (top_rustic->players[j]->alive==1)
            {
            i++;
            move_player(j);
            }
        }

    if (i==0)
        {
        x=0;
        for (j=0; j<top_rustic->total_players; j++)
            if (top_rustic->players[j]->lives>0)
                x+=top_rustic->players[j]->lives;                    
        if (x==0)
            alive=0;
            else
            newgame(cur_level+1);
        }
    }




int combat::game_resize_pictures()
    {
    int x,y;

    int i;

    PX=(int)(game_x/MX);
    PY=(int)(game_y/MY);
    if (PX<1 | PY<1) return(-1);


    int mx,my,j;
    mx=pictures->myimages[0]->data[0];
    my=pictures->myimages[0]->data[1];

    pictures->resize(PX,PY);

    unsigned char *img = new unsigned char[PX*PY];

    if (ginit==1)
        {
        for (i=0; i<max_players; i++)
        for (j=0; j<MAX_ROTS; j++)
            delete player_pictures[i][j];
        }

    for (i=0; i<max_players; i++)
        for (j=0; j<MAX_ROTS; j++)
        {
        mvid *m=pictures->imageint(PLAYER+j);
        int clr;
        int nx,ny;
        for (y=0; y<PY; y++)
            for (x=0; x<PX; x++)
                {
                clr=m->getpixel(x,y);
                if (clr==0) clr=CLEAR_COLOR;
                if (clr!=CLEAR_COLOR)
                    clr=top_rustic->players[i]->color;
                img[y*PX+x]=clr;
                }
        player_pictures[i][j]=makeimage(img,PX,PY);
        }



    playfield->all_on();
    delete [] img;
    ginit=1;
    return(1);
    }


combat::combat(rustic *r)
    : game(r)
    {
    gamename="Combat";
    savescores=0;

    playfield = new pfield(MX,MY);
    playfield->defret=WALL;

    pictures = new graflib("combat.grf");
    refresh_rate=0.035;

    top_rustic->key_form=top_rustic->LET_GO;

    level_data = new levellib("combat.lvl");

    cur_level=-1;
    ticksound.load("tick.wav");
    death.load("scream.wav");
    boomsound.load("bang.wav");
    newgame(0);
    }

combat::~combat()
    {
    delete playfield;
    delete level_data;
    delete pictures;

    int i,j;
    for (i=0; i<max_players; i++)
        for (j=0; j<MAX_ROTS; j++)
            delete player_pictures[i][j];
    }


void combat::newgame(int level)
    {
    int i,x,y;
    
    int newlev=0;
    if (cur_level!=level) newlev=1;

    cur_level=level;


    int cur_screen;
        cur_screen=cur_level%different_levels;

    unsigned char c;


    int cp=0;
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            {
            c=level_data->mylevels[cur_screen]->get(x,y);

            switch (c)
                {
                case PLAYER:
                    top_rustic->players[cp]->dbl_x=x*PICX;
                    top_rustic->players[cp]->dbl_y=y*PICY;
                    top_rustic->players[cp]->x=x*PICX;
                    top_rustic->players[cp]->y=y*PICY;
                    cp++;
                    c=BKGR;
                    break;
                }
                
            if (newlev==1)
               playfield->set(x,y,c);
            }



    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {
        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->j=(i%2)*4;
        top_rustic->players[i]->direction[PLAYER_DOWN]=0;
        }
        else
        top_rustic->players[i]->alive=0;
       


    for (i=0; i<max_balls; i++)
        {
        balls[i].t=0;
        balls[i].alive=0;
        balls[i].owner=i;
        }

    alive=1;
    char s[80];
    sprintf(s,"Round %d",cur_level+1);
    pause(s);
    }



#define ARKX(x) (int)(((x)*PX)/PICX)
#define ARKY(y) (int)(((y)*PY)/PICY)

int combat::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;



    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {
            g->domvid(
                pictures->imageint(playfield->get(x,y)),
                ARKX(x*PICX),ARKY(y*PICY));
            playfield->a_set(x,y,0);
            c++;
            }

    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->alive==1)
                {
                top_rustic->players[i]->moved=0;

                g->idomvid(
                    player_pictures[i][top_rustic->players[i]->j],
                    ARKX(top_rustic->players[i]->x-(PICX/2)),
                    ARKY(top_rustic->players[i]->y-(PICY/2)));

                aset(top_rustic->players[i]->x-(PICX/2),
                     top_rustic->players[i]->y-(PICY/2),
                     PICX,PICY);

                c++;
                }

    for (i=0; i<max_balls; i++)
        if (balls[i].alive==1)
            {
            int clr=15;
            if (balls[i].owner!=-1)
                clr=top_rustic->players[balls[i].owner]->color;

            int rady=5;
            g->fillrect(clr,
                ARKX(balls[i].x-(rady/2)),
                ARKY(balls[i].y-(rady/2)),
                (int)(rady*PX/PICX),
                (int)(rady*PY/PICY));

            aset((int)balls[i].x-(rady/2),(int)balls[i].y-(rady/2),
                rady,rady);
            }
    }

    if (c!=0)
        return(1);

    return(0);
    }

void combat::aset(int x, int y, int mx, int my)
    {
    playfield->a_set((x+0)/PICX,(y+0)/PICY,1);
    playfield->a_set((x+0)/PICX,(y+my)/PICY,1);
    playfield->a_set((x+mx)/PICX,(y+0)/PICY,1);
    playfield->a_set((x+mx)/PICX,(y+my)/PICY,1);
    }

void combat::move_player(int p)
    {
    double x=top_rustic->players[p]->dbl_x;
    double y=top_rustic->players[p]->dbl_y;
    int j=top_rustic->players[p]->j;

    if ((frame_num%5)==0 & top_rustic->players[p]->mx!=0)
        {
        top_rustic->players[p]->moved=1;
        j+=-top_rustic->players[p]->mx;
        if (j==-1) j=MAX_ROTS-1;
        if (j==MAX_ROTS) j=0;
        }


    double cs,sn;

    cs=cos(PI*(-(double)j)/(double)4);
    sn=sin(PI*(-(double)j)/(double)4);
    if (top_rustic->players[p]->direction[PLAYER_UP])
        {
        top_rustic->players[p]->moved=1;

        double mx,my;
        mx=cs*PLAYER_SPEED;
        my=sn*PLAYER_SPEED;

        double cx,cy;
        cx=x;
        cy=y;


        if (playfield->get((int)((cx+mx)/PICX),
                (int)((cy+my)/PICY)) != WALL)
            {
            x+=mx; y+=my;
            }
            else
            if (playfield->get((int)((cx+mx)/PICX),(int)cy/PICY) != WALL)
                x+=mx;
                else
                if (playfield->get((int)cx/PICX,(int)((cy+my)/PICY)) != WALL)
                    y+=my;
        }

    if (top_rustic->players[p]->direction[PLAYER_DOWN]==1)
        { //they shoot!
        if (balls[p].t==0)
            {
            balls[p].t=C_TSTART;
            balls[p].alive=1;
            balls[p].x=x;
            balls[p].y=y;
            balls[p].speed=NORM_BALL_SPEED;
            balls[p].owner=p;
            balls[p].ax=cs;
            balls[p].ay=sn;
            }
        }
        
    top_rustic->players[p]->x=(int)x;
    top_rustic->players[p]->y=(int)y;
    top_rustic->players[p]->dbl_x=x;
    top_rustic->players[p]->dbl_y=y;
    top_rustic->players[p]->j=j;
    }


void combat::kill_player(int p)
    {
    if (top_rustic->players[p]->alive!=0)
        {
        top_rustic->players[p]->alive=0;
        death.play();
        }
    }


void combat::bounce_ball(double ac, double as, double rc, double rs)
    {
    bb_rx=ac*(2*rc*rc-1)+2*as*rs*rc;
    bb_ry=2*ac*rs*rc+as*(1-2*rc*rc);
    }

#define FORCE_SIGN(a,b) ( ((a<0 & b>0)|(a>0 & b<0))?(-b):(b) )

void combat::move_balls()
    {
    int b,i;
    double poss[6] = {
        -7*PI/8,-6*PI/8,
        -5*PI/8,-3*PI/8,
        -2*PI/8,-1*PI/8 };

    for (b=0; b<max_balls; b++)
    if (balls[b].alive==1)
        {
        for (i=0; i<balls[b].speed; i++)
            {
            double nx,ny;
            nx=balls[b].x+balls[b].ax;
            ny=balls[b].y+balls[b].ay;
            int x,y;
            x=(int)nx;
            y=(int)ny;

            unsigned char c;

            int dx,dy;
            dx=((x+PICX)/PICX)-1;
            dy=((y+PICY)/PICY)-1;
            c=playfield->get(dx,dy);

            if (c!=0)
                {
                int px,py;
                px=(x+PICX)%PICX;
                py=(y+PICY)%PICY;

                int er=0;
                if (px==0) er++;
                if (py==0) er++;
                if (px==(PICX-1)) er++;
                if (py==(PICY-1)) er++;

                int way=0;
                if (er==2)
                    {
                    int corner_x=1;
                    int corner_y=1;
                    if (px==0) corner_x=-1;
                    if (py==0) corner_y=-1;

                    int way0=0;
                    int way1=0;

                    if (playfield->get(dx+corner_x,dy)!=0) way1=1;
                    if (playfield->get(dx,dy+corner_y)!=0) way0=1;

                    if (way1 == way0)
                        {
                        way=2;
                        bb_rx=FORCE_SIGN(corner_x,balls[b].ax);
                        bb_ry=FORCE_SIGN(corner_y,balls[b].ay);
                        }
                        else
                        {
                        if (way1>way0)
                            way=1;
                            else
                            way=0;
                        }
                    }
                    else
                    {
                    if (py==0 | py==(PICY-1))
                        way=1;
                    }

                if (way==1)
                    bounce_ball(balls[b].ax,balls[b].ay,1,0);

                if (way==0)
                    bounce_ball(balls[b].ax,balls[b].ay,0,1);

                balls[b].ax=bb_rx;
                balls[b].ay=bb_ry;

                int smack=0;
                int rep=c;

                ticksound.play();

                playfield->set(dx,dy,rep);
                }
                else
                {
                balls[b].x=nx;
                balls[b].y=ny;

                int p;
                for (p=0; p<top_rustic->total_players; p++)
                    if (top_rustic->players[p]->alive==1)
                    if (p!=balls[b].owner |
                        balls[b].t < C_PLETHAL)
                        {
                        if (abs((int)(nx-top_rustic->players[p]->dbl_x)) <=
                            CLOSE_ENOUGH &
                            abs((int)(ny-top_rustic->players[p]->dbl_y)) <=
                            CLOSE_ENOUGH)
                            {                                
                            kill_player(p);
                            if (p!=balls[b].owner)
                                top_rustic->players[balls[b].owner]->score+=100;
                            }
                        }
                }
            }
        balls[b].t--;
        if (balls[b].t==0) balls[b].alive=0;
        }
    }



void combat::bendangle(int b, double an)
    {
    double ca,sa;
    ca=cos(an);
    sa=sin(an);

    double nx,ny;
    double ox,oy;
    ox=balls[b].ax;
    oy=balls[b].ay;

    nx=ox*ca-oy*sa;
    ny=ox*sa+oy*ca;

    balls[b].ax=nx;
    balls[b].ay=ny;
    }

void combat::changeangle(int b, double an)
    {
    double ca,sa;
    ca=cos(an);
    sa=sin(an);
    balls[b].ax=ca;
    balls[b].ay=sa;
    }




