#include "rustic.h"
#include "menu.h"

#include <ctype.h>
#include <string.h>

typedef struct {
    long score;
    char name[MAX_PNAMELEN+1];
    } hs_entry;


#define MAX_HSENTRIES 10

#define SCORES_DOWN  5
#define TEXTS_ON_HS  20
#define SLIST_WIDTH  25
#define NAMEPOS       4

class highscore : public panel
    {
    public:

    int firsttime;
    rustic *top_rustic;
    char *gamename;
    char hsname[14];
    sfont *myfont;
    int ox;


    hs_entry highscores[MAX_HSENTRIES];
    edit_textbox *newnames[max_players];

    void loadscores()
        {
        FILE *stream;
        stream=fopen(hsname,"rb");
        if (stream!=0)
            {
            fread(&highscores,MAX_HSENTRIES,sizeof(hs_entry),stream);
            fclose(stream);
            }
            else
            {
            int i;
            for (i=0; i<MAX_HSENTRIES; i++)
                {
                highscores[i].score=100;
                sprintf(highscores[i].name,"Phil");
                }
            }

        int j=0;
        int k,l;
        for (k=0; k<top_rustic->total_players; k++)
            top_rustic->players[k]->p=MAX_HSENTRIES;
        int ord[max_players];

        for (j=0; j<top_rustic->total_players; j++)
            ord[j]=j;

        for (j=0; j<top_rustic->total_players; j++)
            for (k=0; k<top_rustic->total_players-1; k++)
                {
                if (top_rustic->players[ord[k]]->score <
                    top_rustic->players[ord[k+1]]->score)
                    {
                    l=ord[k];
                    ord[k]=ord[k+1];
                    ord[k+1]=l;
                    }
                }

        for (j=0; j<max_players; j++)
            newnames[j]=0;

        for (j=0; j<top_rustic->total_players; j++)
            {
            for (k=0; k<MAX_HSENTRIES; k++)
                {
                if (top_rustic->players[ord[j]]->score>
                    highscores[k].score)
                    {
                    for (l=MAX_HSENTRIES-1; l>k; l--)
                        {
                        highscores[l].score=highscores[l-1].score;
                        sprintf(highscores[l].name,highscores[l-1].name);
                        }
                    top_rustic->players[ord[j]]->p=k;
                    highscores[k].score=top_rustic->players[ord[j]]->score;
                    sprintf(highscores[k].name,
                        top_rustic->players[ord[j]]->name);
                    newnames[j]=new edit_textbox(
                        myfont,highscores[k].name,
                        MAX_PNAMELEN);
                    add(newnames[j],0,PANEL_PERCENT |
                        ((100/TEXTS_ON_HS)*(SCORES_DOWN+k)));                               
                    k=MAX_HSENTRIES;
                    }
                }
            }
        }

    void savescores()
        {
        FILE *stream;
        stream=fopen(hsname,"wb");
        fwrite(&highscores,MAX_HSENTRIES,sizeof(hs_entry),stream);
        fclose(stream);
        }

    highscore(rustic *r, char *gn)
        : panel(PANEL_ENTIRE,PANEL_ENTIRE)
        {
        gamename=gn;
        top_rustic=r;
        firsttime=1;

        int i;
        long l=strlen(gamename);
        if (l>8) l=8;
        for (i=0; i<l; i++)
            {
            hsname[i]=tolower(gamename[i]);
            if ((hsname[i]<'a' | hsname[i]>'z') &
                (hsname[i]<'0' | hsname[i]>'9'))
                hsname[i]='_';
            }
        hsname[l]=0;
        sprintf(hsname,"%s.hs",hsname);

        myfont=new graffont(RUSTIC_FONT);
        myfont->fg=14;
        myfont->bg=4;

        loadscores();
        }

    void resize()
        {
        int fs=MY/TEXTS_ON_HS;
        myfont->MY=fs;
        myfont->MX=MX/SLIST_WIDTH;

        ox=(MX-(SLIST_WIDTH*myfont->MX))/2;

        firsttime=1;

        int i;
        for (i=0; i<max_players; i++)
            if (newnames[i]!=0)
                newnames[i]->sPX=(myfont->MX*NAMEPOS)+ox;

        panel::resize();
        }

    int update(vid *onto)
        {
        if (firsttime==1)
            {
            int fs=MY/TEXTS_ON_HS;
            sfont *bgfont=new graffont(RUSTIC_FONT,fs);
            bgfont->MX=myfont->MX;
            int bg=1;
            int fg=15;
            bgfont->bg=bg;
            bgfont->fg=fg;
            int ox2=ox+(bgfont->MX/2);

            onto->fillrect(bg,0,0,MX,MY);
            bgfont->print_text(onto,"H I G H <> S C O R E S !",ox2,0);

            int i;
            char s[160];
            for (i=0; i<MAX_HSENTRIES; i++)
                {
                sprintf (s,"%2d. %-12s  %7ld",i+1,
                    highscores[i].name,highscores[i].score);
                bgfont->print_text(onto,s,ox,fs*(i+SCORES_DOWN));
                }

            bgfont->print_text(onto,"press escape to continue",ox2,MY-fs);
            delete bgfont;
            firsttime=0;
            }
        panel::update(onto);
        }

    void key(keyevent *e)
        {
        switch(e->k)
            {
            case KEY_ESC:
                top_rustic->change_screen(new rusticmenu(top_rustic));
		break;
            default:
		panel::key(e);
            	break;
            }
        }

    ~highscore()
        {
        savescores();
        int i;
        for (i=0; i<max_players; i++)
            if (newnames[i]!=0)
                delete newnames[i];
        delete myfont;
        }
    };
