#include "pacman.h"


void pacman::next_turn()
    {
    int x,y,i,j;

    if (special==1)
        {
        special=0;
        newgame(cur_level+1);
        }

    i=0;

    int q;

    move_ghosts();

    for (j=0; j<top_rustic->total_players; j++)
        {
        if (top_rustic->players[j]->alive==1)
            {
            i++;
            move_player(j);
            }
        }

    int adlev=0;
    j=0;
    for (x=0; x<MX; x++)
        for (y=0; y<MY; y++)
            if (playfield->get(x,y)==PILL) j++;
    if (j==0) {adlev=1;i=0;}

    if (i==0)
        {
        x=0;
        for (j=0; j<top_rustic->total_players; j++)
            if (top_rustic->players[j]->lives>0)
                x+=top_rustic->players[j]->lives;                    
        if (x==0)
            alive=0;
            else
            newgame(cur_level+adlev);
        }

    }




int pacman::game_resize_pictures()
    {
    int x,y;

    int i;

    PX=game_x/MX;
    PY=game_y/MY;
    if (PX<1 | PY<1) return(-1);

//        PX=8;
//        PY=8;
    unsigned char *img = new unsigned char[PX*PY];
    int mx,my; int j,k;

    pictures->resize(PX,PY);

    if (ginit==1)
        {
        for (i=0; i<max_players; i++) delete player_pictures[i];
        }

    for (i=0; i<max_players; i++)
        {
        for (y=0; y<PY; y++)
            for (x=0; x<PX; x++)
                if (sqrt((x-PX/2)*(x-PX/2)+
                    (y-PY/2)*(y-PY/2))<(PX/2))
                    img[y*PX+x]=top_rustic->players[i]->color;
                    else
                    img[y*PX+x]=CLEAR_COLOR;
        player_pictures[i]=makeimage(img,PX,PY);
        }

   /* for (i=0; i<MX*MY; i++)
        a_play_field[i]=1;
    */
    playfield->all_on();
    delete [] img;
    ginit=1;
    return(1);
    }


pacman::pacman(rustic *r)
    : game(r)
    {
    gamename="Pacman";
    playfield = new pfield(MX,MY);

    PX=8;
    PY=8;

    pictures = new graflib("pacman.grf");
    refresh_rate=.13f/(float)div_thing;

    top_rustic->key_form=top_rustic->LET_GO;

    level_data = new levellib("pacman.lvl");
    cur_level=-1;

    death.load("scream.wav");
    bonus.load("trumpet.wav");
    pill.load("tick.wav");
    newgame(0);
    }

pacman::~pacman()
    {
    delete playfield;
    delete level_data;
    delete pictures;
    int i;
    for (i=0; i<max_players; i++)
        delete player_pictures[i];
    }

int pacman::pplayfield_get(int p, int x,int y)
    {
    int px,py;
    int pxd,pyd;
    px=top_rustic->players[p]->x;
    py=top_rustic->players[p]->y;
    pxd=px/div_thing;
    pyd=py/div_thing;

    int dx,dy;
    dx=x-pxd;
    dy=y-pyd;

    int tdx=0,tdy=0;
    if (dx<0) {tdx=-div_thing/2-1;dx++;}
    if (dy<0) {tdy=-div_thing/2-1;dy++;}
    if (dx>0) {tdx=div_thing/2;dx--;}
    if (dy>0) {tdy=div_thing/2;dy--;}
    tdx+=dx*div_thing;
    tdy+=dy*div_thing;

    x=px+tdx+div_thing/2;
    y=py+tdy+div_thing/2;
    x/=div_thing;
    y/=div_thing;
    
    return(playfield->get(x,y));
    }

void pacman::pplayfield_set(int p, int x, int y, int c)
    {
    int px,py;
    int pxd,pyd;
    px=top_rustic->players[p]->x;
    py=top_rustic->players[p]->y;
    pxd=px/div_thing;
    pyd=py/div_thing;

    int dx,dy;
    dx=x-pxd;
    dy=y-pyd;

    int tdx=0,tdy=0;
    if (dx<0) {tdx=-div_thing/2-1;dx++;}
    if (dy<0) {tdy=-div_thing/2-1;dy++;}
    if (dx>0) {tdx=div_thing/2;dx--;}
    if (dy>0) {tdy=div_thing/2;dy--;}
    tdx+=dx*div_thing;
    tdy+=dy*div_thing;

    x=px+tdx+div_thing/2;
    y=py+tdy+div_thing/2;
    x/=div_thing;
    y/=div_thing;
    
    playfield->set(x,y,c);
    }


void pacman::newgame(int level)
    {
    int i,x,y;

    int newlev=0;
    if (cur_level!=level) newlev=1;
    
    cur_level=level;

    int sx,sy;
    sx=1;
    sy=2;
    int c;
    i=0;

    int j=0;
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            {
            c=level_data->mylevels[cur_level%different_levels]->get(x,y);
            switch(c)
                {
                case GHOST:
                    if (i<max_ghosts)
                        {
                        ghosts[i].x=x*div_thing;
                        ghosts[i].y=y*div_thing;
                        ghosts[i].t=0;
                        }
                    i++;
                    c=0;
                    break;
                case PLAYER:
                    if (j<top_rustic->total_players)
                        {
                        top_rustic->players[j]->x=x*div_thing;
                        top_rustic->players[j]->y=y*div_thing;
                        }
                    j++;
                    c=0;
                    break;
                }
            if (newlev==1)
                playfield->set(x,y,c);
            }



    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {
 //       top_rustic->players[i]->x=MX/4+(MX/2)*(i%2);
 //       top_rustic->players[i]->y=MY/4+(MY/2)*(i/2);

        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->j=0;
 //       playfield->set(top_rustic->players[i]->x,top_rustic->players[i]->y,BKGR);
        }

    alive=1;
    char s[80];
    sprintf(s,"Round %d",cur_level+1);
    pause(s);
    }



int pacman::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;

    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {
            g->domvid(
                pictures->imageint(playfield->get(x,y)),
                x*PX,y*PY);
            playfield->a_set(x,y,0);
            c++;
            }

    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->alive==1)
            if (top_rustic->players[i]->moved==1)
                {
                top_rustic->players[i]->moved=0;

                if (top_rustic->players[i]->j==0)
                g->idomvid(player_pictures[i],top_rustic->players[i]->x*PX/div_thing,
                top_rustic->players[i]->y*PY/div_thing);
                else
                g->idomvid(player_pictures[rand()%max_players],top_rustic->players[i]->x*PX/div_thing,
                top_rustic->players[i]->y*PY/div_thing);
                c++;
                }

    for (i=0; i<max_ghosts; i++)
            if (ghosts[i].moved==1)
                {
                ghosts[i].moved=0;
                g->idomvid(
                    pictures->imageint(GHOST),ghosts[i].x*PX/div_thing,
                    ghosts[i].y*PY/div_thing);
                c++;
                }



    }



    if (c!=0)
        return(1);

    return(0);
    }


void pacman::move_player(int p)
    {
    int j;
    int x=top_rustic->players[p]->x;
    int y=top_rustic->players[p]->y;
    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;


    if (top_rustic->players[p]->j>0) top_rustic->players[p]->j--;
    key_check(p);
    check(p);

    if (top_rustic->players[p]->j!=0) top_rustic->players[p]->moved=1;


    if (x!=top_rustic->players[p]->x | y!=top_rustic->players[p]->y)
        {

        for (j=0; j<top_rustic->total_players; j++)
            top_rustic->players[j]->moved=1;

        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));

        x-=div_thing-1;
        y+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        }
}


/*
void pacman::key_check(int p)
  {
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;


  int i;

  int k;

    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;

if (pplayfield_get(p,x+mx,y+my) != WALL)
    {
    x+=mx; y+=my;
    }
    else
    if (pplayfield_get(p,x+mx,y) != WALL)
        x+=mx;
        else
        if (pplayfield_get(p,x,y+my) != WALL)
            y+=my;

  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  //return (0);
  }
*/

void pacman::key_check(int p)
  {
  int fx=top_rustic->players[p]->x;//div_thing;
  int fy=top_rustic->players[p]->y;//div_thing;
  int x=fx/div_thing;
  int y=fy/div_thing;


  int i;

  int k;

    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;




//        if (pplayfield_get(p,x,y+my) != DIRT)

int omy=my;
int omx=mx;

int hdt=div_thing/2;

if ((fx%div_thing)!=0) my=0;
if ((fy%div_thing)!=0) mx=0;

if (mx!=0 & my!=0)
    if (pplayfield_get(p,x+mx,y) != WALL)
        {omy=0;my=0;}
        else
        {omx=0;mx=0;}

if (omx==0 & mx==0 & omy!=my)
    if (fx%div_thing<hdt)
        mx=-1;  else  mx=1;

if (omy==0 & my==0 & omx!=mx)
    if (fy%div_thing<hdt)
        my=-1;  else  my=1;

int rp=top_rustic->players[p]->p;


if (mx!=0 | my!=0)
    {
    if (mx!=0)
        {
        if (mx<0) rp=PLAYER_LEFT;
            else
            rp=PLAYER_RIGHT;
        }
        else
        {
        if (my<0)
            rp=PLAYER_UP;
            else
            rp=PLAYER_DOWN;
        }
    }
top_rustic->players[p]->p=rp;
            

        
//push_gold(p,mx,fx,fy);

if (pplayfield_get(p,x+mx,y+my) != WALL)
    {
    x+=mx; y+=my;
    }
    else
    if (pplayfield_get(p,x+mx,y) != WALL)
        x+=mx;
        else
        if (pplayfield_get(p,x,y+my) != WALL)
            y+=my;



  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);

  if (top_rustic->players[p]->x<0) top_rustic->players[p]->x=0;
  if (top_rustic->players[p]->y<0) top_rustic->players[p]->y=0;

  //return (0);
  }


int pacman::gplayfield_get(int p, int x,int y)
    {
    int px,py;
    int pxd,pyd;
    px=ghosts[p].x;
    py=ghosts[p].y;
    pxd=px/div_thing;
    pyd=py/div_thing;

    int dx,dy;
    dx=x-pxd;
    dy=y-pyd;

    int tdx=0,tdy=0;
    if (dx<0) {tdx=-div_thing/2-1;dx++;}
    if (dy<0) {tdy=-div_thing/2-1;dy++;}
    if (dx>0) {tdx=div_thing/2;dx--;}
    if (dy>0) {tdy=div_thing/2;dy--;}
    tdx+=dx*div_thing;
    tdy+=dy*div_thing;

    x=px+tdx+div_thing/2;
    y=py+tdy+div_thing/2;
    x/=div_thing;
    y/=div_thing;
    
    return(playfield->get(x,y));
    }


void pacman::move_ghosts()
{
int x,y,i,j;
for (i=0; i<max_ghosts; i++)
    {

    x=ghosts[i].x;
    y=ghosts[i].y;

        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));

        x-=div_thing-1;
        y+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));


    ghosts[i].moved=1;

    x=ghosts[i].x;
    y=ghosts[i].y;

    int mx,my;

    mx=ghosts[i].mx;
    my=ghosts[i].my;
    int xd,yd;
    xd=x/div_thing;
    yd=y/div_thing;

if (gplayfield_get(i,xd+mx,yd+my) != WALL)
    {
    x+=mx; y+=my;
    }
    else
    if (gplayfield_get(i,xd+mx,yd) != WALL)
        x+=mx;
        else
        if (gplayfield_get(i,xd,yd+my) != WALL)
            y+=my;


    if (x!=ghosts[i].x | y!=ghosts[i].y)
        {
        ghosts[i].t--;
   //         ghosts[i].x+=ghosts[i].mx;
//        ghosts[i].y+=ghosts[i].my;
        ghosts[i].y=y;
        ghosts[i].x=x;
        }
        else
        ghosts[i].t=0;
    if (ghosts[i].t<=0)
        {
        ghosts[i].t=1+rand()%50;
        ghosts[i].mx=1-(2*(rand()%2));
        ghosts[i].my=1-(2*(rand()%2));
        }
    }
}

void pacman::kill_player(int p)
{
top_rustic->players[p]->lives--;
top_rustic->players[p]->alive=0;
death.play();
}

void pacman::check(int p)
  {
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;
  int j=top_rustic->players[p]->j;
  int score=top_rustic->players[p]->score;


  if (pplayfield_get(p,x,y) ==  PILL) { score=score+10;pplayfield_set(p,x,y,0); pill.play();}
  if (pplayfield_get(p,x,y) ==  BONUS) {bonus.play(); score=score+50;pplayfield_set(p,x,y,0);
j+=150; }

  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->score=score;

  int i;
  if (top_rustic->players[p]->j==0)
  for (i=0; i<max_ghosts; i++)
    {
    if (abs(ghosts[i].x-top_rustic->players[p]->x) < 4 &
        abs(ghosts[i].y-top_rustic->players[p]->y) < 4)
        {
        kill_player(p);
        }
    }

  for (i=0; i<top_rustic->total_players; i++)
if (i!=p & top_rustic->players[i]->alive==1)
    {
    if (abs(top_rustic->players[i]->x-top_rustic->players[p]->x) < 4 &
        abs(top_rustic->players[i]->y-top_rustic->players[p]->y) < 4)
        {
        if (top_rustic->players[p]->j==0)
            kill_player(p);

        if (top_rustic->players[i]->j==0)
            kill_player(i);
        }
    }
  }

