#include "tetris.h"
int tetris_pieces[] = {
0,1,0,0,    1,1,1,1,    0,1,0,0,    1,1,1,1,
0,1,0,0,    0,0,0,0,    0,1,0,0,    0,0,0,0,
0,1,0,0,    0,0,0,0,    0,1,0,0,    0,0,0,0,
0,1,0,0,    0,0,0,0,    0,1,0,0,    0,0,0,0,

1,1,1,0,    0,1,0,0,    0,1,0,0,    0,0,1,0,
0,1,0,0,    0,1,1,0,    1,1,1,0,    0,1,1,0,
0,0,0,0,    0,1,0,0,    0,0,0,0,    0,0,1,0,
0,0,0,0,    0,0,0,0,    0,0,0,0,    0,0,0,0,

0,1,0,0,    0,0,1,0,    0,1,1,0,    1,1,1,0,
0,1,0,0,    1,1,1,0,    0,0,1,0,    1,0,0,0,
0,1,1,0,    0,0,0,0,    0,0,1,0,    0,0,0,0,
0,0,0,0,    0,0,0,0,    0,0,0,0,    0,0,0,0,

0,0,1,0,    1,1,1,0,    0,1,1,0,    1,0,0,0,
0,0,1,0,    0,0,1,0,    0,1,0,0,    1,1,1,0,
0,1,1,0,    0,0,0,0,    0,1,0,0,    0,0,0,0,
0,0,0,0,    0,0,0,0,    0,0,0,0,    0,0,0,0,

0,1,1,0,    0,1,1,0,    0,1,1,0,    0,1,1,0,
0,1,1,0,    0,1,1,0,    0,1,1,0,    0,1,1,0,
0,0,0,0,    0,0,0,0,    0,0,0,0,    0,0,0,0,
0,0,0,0,    0,0,0,0,    0,0,0,0,    0,0,0,0,

1,1,0,0,    0,0,1,0,    1,1,0,0,    0,0,1,0,
0,1,1,0,    0,1,1,0,    0,1,1,0,    0,1,1,0,
0,0,0,0,    0,1,0,0,    0,0,0,0,    0,1,0,0,
0,0,0,0,    0,0,0,0,    0,0,0,0,    0,0,0,0,

0,1,1,0,    0,1,0,0,    0,1,1,0,    0,1,0,0,
1,1,0,0,    0,1,1,0,    1,1,0,0,    0,1,1,0,
0,0,0,0,    0,0,1,0,    0,0,0,0,    0,0,1,0,
0,0,0,0,    0,0,0,0,    0,0,0,0,    0,0,0,0};

int tetris::piece(int p, int x, int y, int r)
    {
    int i;
    i=p*64;
    i+=y*16;
    i+=r*4;
    i+=x;
    if (i>(numpieces*64)) return(0);

    return(tetris_pieces[i]);
    }




void tetris::next_turn()
    {
    int x,y,i,j;

    if (count==nxt)
        if (refresh_rate>.02f) // due to "i_love_bill" timer limitation
            {
            refresh_rate-=.01f;
            add_next();
            }

    i=0;
    for (j=0; j<top_rustic->total_players; j++)
        if (top_rustic->players[j]->alive==1)
            {
            i++;
            move_player(j);
            }

    x=0;
    if (i==0)
        {
        for (j=0; j<top_rustic->total_players; j++)
            if (top_rustic->players[j]->lives>0)
                x+=top_rustic->players[j]->lives;                    
        if (x==0)
            alive=0;
            else
            newgame(1);
        }

    count++;
    }


int tetris::game_resize_pictures()
    {
    int x,y;

    int i;

    PX=game_x/MX;
    PY=game_y/MY;
    if (PX<1 | PY<1) return(-1);

//      for (i=0; i<MX*MY; i++)
    playfield->all_on();

    ginit=1;
    return(1);
    }


tetris::tetris(rustic *r)
    : game(r)
    {
    gamename="Tetris";
    fX=8;
  //  MX=1+((fX+1)*top_rustic->max_players);
    MX=37;
    MY=23;
    count=1;
    nxt=0;

    playfield=new pfield(MX,MY);

    refresh_rate=.1f;
    top_rustic->key_form=top_rustic->HIT_ON;
    rotate.load("doy.wav");
    drop.load("tick.wav");
    line.load("bang.wav");
    newgame(1);
    }

tetris::~tetris()
    {
    delete playfield;
    }

void tetris::add_next()
    {
    nxt+=(int)(((float)1.0/refresh_rate)*20);
    }


void tetris::newgame(int level)
    {
    int i,x,y;
    count=1;
    refresh_rate=.1f;
    nxt=0;
    add_next();
    for (x=0; x<MX; x++)
        for (y=0; y<MY; y++)
            playfield->set(x,y,BKGR);
    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {

        top_rustic->players[i]->y=0;
        top_rustic->players[i]->p=rand()%numpieces;
        top_rustic->players[i]->j=rand()%4;
        top_rustic->players[i]->r=1+i*(fX+1)+(MX/2-((fX+1)*top_rustic->total_players)/2);
        top_rustic->players[i]->x=top_rustic->players[i]->r+fX/2-1;
        for (x=0; x<fX+2; x++)
            playfield->set(top_rustic->players[i]->r-1+x,MY-1,WALL);
        for (y=0; y<MY; y++)
            {
            playfield->set(top_rustic->players[i]->r-1,y,WALL);
            playfield->set(top_rustic->players[i]->r+fX,y,WALL);
            }
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->calc_mxmy();
        }

    alive=1;
    pause("Get Ready");
    }



int tetris::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;
    int color=-1;  int nc;
    int newc;
    
    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {
            nc=playfield->get(x,y);
            if (nc!=color)
                {
                color=nc;
                if (nc==0 | nc==15)
                    newc=nc;
                    else
                    newc=top_rustic->players[nc-1]->color;
                }

            if (nc!=15)
                g->fillrect(newc,x*PX,y*PY,PX-1,PY-1);
                else
                g->fillrect(newc,x*PX,y*PY,PX,PY);
            playfield->a_set(x,y,0);
            c++;
            }
    }

    if (c!=0)
        return(1);

    return(0);
    }

void tetris::move_player(int p)
    {
    int np=0;
    int x=top_rustic->players[p]->x;
    int y=top_rustic->players[p]->y;
    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;

    int i,j,xx,yy;
    int nx,ny;

    nx=x+mx;ny=y+my;

    int r=0;


    int m,n;

    for (m=0; m<4; m++)
        for (n=0; n<4; n++)
            if (piece(top_rustic->players[p]->p,m,n,top_rustic->players[p]->j)!=0)
                playfield->set(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y,0);

    if (top_rustic->players[p]->direction[PLAYER_UP]==1)
        {
        j=top_rustic->players[p]->j;
        top_rustic->players[p]->j++;
        if(top_rustic->players[p]->j==4) top_rustic->players[p]->j=0;
        if (checkpiece(p)!=0)
            top_rustic->players[p]->j=j;
            else
            rotate.play();
        top_rustic->players[p]->direction[PLAYER_UP]=0;
        }

    top_rustic->players[p]->x+=mx;
    top_rustic->players[p]->direction[PLAYER_LEFT]=0;
    top_rustic->players[p]->direction[PLAYER_RIGHT]=0;

    if (checkpiece(p)!=0)
        top_rustic->players[p]->x-=mx;

    if (top_rustic->players[p]->direction[PLAYER_DOWN]==1)
        {
        //top_rustic->players[p]->y++;
        //if (checkpiece(p)!=0)
         //   {
	while(checkpiece(p)==0) top_rustic->players[p]->y++;
            top_rustic->players[p]->y--;
            np=1;
          //  }
        }

    if ((count%8)==0)
        {
        top_rustic->players[p]->y++;
        if (checkpiece(p)!=0)
            {
            top_rustic->players[p]->y--;
            np=1;
            }
        }

    for (m=0; m<4; m++)
        for (n=0; n<4; n++)
            if (piece(top_rustic->players[p]->p,m,n,top_rustic->players[p]->j)!=0)
                playfield->set(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y,p+1);
              
    if (np==1) {newpiece(p); drop.play(); }
    }

int tetris::checkpiece(int p)
    {
    int i=0;
    int m,n;
    for (m=0; m<4; m++)
        for (n=0; n<4; n++)
            if (piece(top_rustic->players[p]->p,
            m,n,top_rustic->players[p]->j)!=0)
                i+=playfield->get(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y);
    return(i);
    }

void tetris::newpiece(int p)
    {
    if (top_rustic->players[p]->y==0)
        {
        top_rustic->players[p]->alive=0;
        top_rustic->players[p]->lives--;
        }

        top_rustic->players[p]->y=0;
        top_rustic->players[p]->x=top_rustic->players[p]->r+fX/2-1;
        top_rustic->players[p]->p=rand()%4;

    top_rustic->players[p]->score+=10;

    int x,y,i,j,q;
    q=1;
    for (y=0; y<MY-1; y++)
        {
        i=0;
        for (x=0; x<fX; x++)
            if (playfield->get(x+top_rustic->players[p]->r,y)!=0)
                i++;
        if (i==fX)
            {
            line.play();
            top_rustic->players[p]->score+=150*q;
            q++;
            for (j=y; j>=0; j--)
                for (x=0; x<fX; x++)
                    playfield->set(x+top_rustic->players[p]->r,j,
                    playfield->get(x+top_rustic->players[p]->r,j-1));

            for (j=0; j<top_rustic->total_players; j++)
                if (j!=p)
                    addline(j,p);
            }
        }
    }

void tetris::addline(int p, int f)
    {
    int m,n,x,y,i,j;

    if (top_rustic->players[p]->alive==1)
    for (m=0; m<4; m++)
        for (n=0; n<4; n++)
            if (piece(top_rustic->players[p]->p,m,n,top_rustic->players[p]->j)!=0)
                playfield->set(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y,0);

    for (y=0; y<MY-2; y++)
        for(x=0; x<fX; x++)
            playfield->set(x+top_rustic->players[p]->r,y,
            playfield->get(x+top_rustic->players[p]->r,y+1));
    for (x=0; x<fX; x++)
        playfield->set(x+top_rustic->players[p]->r,
            MY-2, f+1);
    playfield->set(top_rustic->players[p]->r+rand()%fX,MY-2,0);

    if (top_rustic->players[p]->alive==1)
    if (checkpiece(p)!=0)
        {
        top_rustic->players[p]->y--;
        for (m=0; m<4; m++)
            for (n=0; n<4; n++)
                if (piece(top_rustic->players[p]->p,m,n,top_rustic->players[p]->j)!=0)
                    playfield->set(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y,p+1);

        drop.play(); newpiece(p);
        }

    if (top_rustic->players[p]->alive==1)
    for (m=0; m<4; m++)
        for (n=0; n<4; n++)
            if (piece(top_rustic->players[p]->p,m,n,top_rustic->players[p]->j)!=0)
                playfield->set(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y,p+1);
    }


