#include "dvidw.h"

//#include <conio.h>
#include <stdio.h>

#ifdef DOS
    #include <stdlib.h>
    #include <stdio.h>
    #include <sys/farptr.h>
    #include <sys/segments.h>
    #include <sys/movedata.h>
#endif


dvidw::dvidw(int params=0, int mx=0, int my=0)
    : dvid()
    {
    myparams=params;
    dbuf=0;

    if (mx==0 | my==0)
    {
        int vmode=0;
        int nres=3;
        int res[][2] = {320,200,640,480,800,600};
        printf ("\nVID Graphics (Using Allegro)\n-----------------\n");
        for (int i=0; i<nres; i++)
            printf ("%d. %dx%d\n",i+1,res[i][0],res[i][1]);
        printf ("Choose a mode: ");
        scanf("%d",&vmode);
        vmode--;
        mx=res[vmode][0];
        my=res[vmode][1];
    }

    resize(mx,my);

    dopal16();
    showpal();
    clearvid();
    }

dvidw::~dvidw()
    {
    }

void dvidw::resize(int mx , int my)
    {
    vid::resize(mx,my);
    allegro_init();

    #ifdef ALLEGRO_DJGPP
    if (MX>320)
        set_gfx_mode(GFX_VESA1,MX,MY,0,0);
        else
        set_gfx_mode(GFX_MODEX,MX,MY,0,0);
    #else
    set_gfx_mode(GFX_AUTODETECT,MX,MY,0,0);
    #endif

	using_simplemode=1;

if (dbuf !=0) destroy_bitmap(dbuf);

	
    if ((myparams&DVIDW_DIRECT_WRITES)==0)
        dbuf=create_bitmap(mx,my);
        else
        dbuf=screen;
    }


void dvidw::showpal(void)
    {
    int i;
    PALLETE pallete;
    for (i=0; i<256; i++)
        {
        pallete[i].r=pal[i][0]>>2;
        pallete[i].g=pal[i][1]>>2;
        pallete[i].b=pal[i][2]>>2;
        }
    set_pallete(pallete);
    }

void dvidw::display_area(unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
    {
    if (x>MX | y>MY) return;
    if (mx>MX | my>MY) return;
    if ((x+mx)>MX | (y+my)>MY) return;

    if ((myparams&DVIDW_DIRECT_WRITES)==0)
        {
        /*
        #ifdef DOS
        if (using_simplemode==1)
            {
            unsigned int yy;
            unsigned long address;
            unsigned myds=_my_ds();
            unsigned fromad=(unsigned)(dbuf->dat)+x+(y*MX);
            for (yy=0; yy<my; yy++)
                {
                address = bmp_write_line(screen, y+yy);
                movedata(myds, fromad, screen->seg, address+x, mx);
                fromad+=MX;
                }
            }
            else
            {
            blit(dbuf,screen,x,y,x,y,mx,my);
            }
        #else
        */
        blit(dbuf,screen,x,y,x,y,mx,my);
       // #endif
        }
    }

void dvidw::fillrect(unsigned char c, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
    {
    rectfill(dbuf,x,y,x+mx-1,y+my-1,c);
    }

void dvidw::dopixel(unsigned char c, unsigned int x, unsigned int y)
    {
    putpixel(dbuf,x,y,c);
    }

void dvidw::doblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
    {
    if ((x+mx)>MX | (y+my)>MY) return;
    unsigned int xx,yy;

    long i=0;
    for (yy=y; yy<y+my; yy++)
        for (xx=x; xx<x+mx; xx++)
            {
            putpixel(dbuf,xx,yy,v[i]);
            i++;
            }
    }

void dvidw::idoblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
    {
    if ((x+mx)>MX | (y+my)>MY) return;
    unsigned int xx,yy;
    long i=0;
    unsigned char c;

    for (yy=y; yy<y+my; yy++)
        for (xx=x; xx<x+mx; xx++)
            {
            c=v[i]; i++;
            if (c!=CLEAR_COLOR)
                putpixel(dbuf,xx,yy,c);
            }
    }

int dvidw::getpixel(unsigned int x, unsigned int y)
    {
    return(::getpixel(dbuf,x,y));
    }


void dvidw::getblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
    {
    if ((x+mx)>MX | (y+my)>MY) return;
    unsigned int xx,yy;
    long i=0;
    for (yy=y; yy<y+my; yy++)
        for (xx=x; xx<x+mx; xx++)
            {
            v[i]=::getpixel(dbuf,xx,yy);
            i++;
            }
    }


void dvidw::domvid(mvid *v, unsigned int x, unsigned int y)
    {
    blit(v->mybitmap,dbuf,0,0,x,y,v->MX,v->MY);
//    blit(dbuf,dbuf,0,0,-1,0,MX,MY);
    }

void dvidw::idomvid(mvid *v, unsigned int x, unsigned int y)
    {
//    vid::idomvid(v,x,y);
int xx,yy;
unsigned char *d=v->getmpointer();
int i;
i=0;
for (xx=0; xx<v->MX; xx++)
	for (yy=0; yy<v->MY; yy++)
		{
			switch(d[i])
			{
				case 0:
					d[i]=16;
					break;
				case 16:
					d[i]=0;
					break;
			}
			i++;
		}
	    
	    masked_blit(v->mybitmap,dbuf,0,0,x,y,v->MX,v->MY); //(v,x,y);
	    //blit(v->mybitmap,dbuf,0,0,x,y,v->MY,v->MY);

    
i=0;
for (xx=0; xx<v->MX; xx++)
	for (yy=0; yy<v->MY; yy++)
		{
			switch(d[i])
			{
				case 0:
					d[i]=16;
					break;
				case 16:
					d[i]=0;
					break;
			}
			i++;
		}
    
    }

unsigned char *dvidw::getmpointer()
    {
    if (
        (myparams&DVIDW_DIRECT_WRITES)==0 &
        using_simplemode==1
        )
        {
        return((unsigned char *)dbuf->dat);
        }
    return(0);
    }


/*
but i'm taking it out, 'cause it's not compatible with all the versions of
allegro.. and it's kinda weird.
//here's some DJGPP / Allegro stuff to get the exe smaller..

BEGIN_GFX_DRIVER_LIST
    GFX_DRIVER_VGA
    GFX_DRIVER_MODEX
    GFX_DRIVER_VESA1
END_GFX_DRIVER_LIST

BEGIN_COLOR_DEPTH_LIST
    COLOR_DEPTH_8
END_COLOR_DEPTH_LIST

BEGIN_JOYSTICK_DRIVER_LIST
END_JOYSTICK_DRIVER_LIST
*/
