#include "mvid.h"


#ifdef DOS
    #include <stdlib.h>
    #include <stdio.h>
    #include <sys/farptr.h>
    #include <sys/segments.h>
    #include <sys/movedata.h>
#endif


mvid::mvid(unsigned int mx, unsigned int my)
    {
    MX=mx;MY=my;
    //vmem=new unsigned char[MX*MY];
    mybitmap=create_bitmap(MX,MY);
    vmem=(unsigned char *)mybitmap->dat;
    }

mvid::mvid()
    {
    MX=0;
    MY=0;
    }

mvid::~mvid()
    {
    if (MX!=0 & MY!=0)
        destroy_bitmap(mybitmap);
    }

void mvid::resize(int mx, int my)
    {
    if (MX!=0 & MY!=0)
        destroy_bitmap(mybitmap);

    vid::resize(mx,my);

    mybitmap=create_bitmap(MX,MY);
    vmem=(unsigned char *)mybitmap->dat;
    }

void mvid::fillrect(unsigned char c, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
    {
    if ((x+mx)>MX | (y+my)>MY) return;                      

    unsigned int xx,yy;
    for (yy=0; yy<my; yy++)
        for (xx=0; xx<mx; xx++)
            vmem[(xx+x)+(yy+y)*MX]=c;
    }

void mvid::dopixel(unsigned char c, unsigned int x, unsigned int y)
    {
    if (x>=MX | y>=MY) return;
    vmem[x+y*MX]=c;
    }

int mvid::getpixel(unsigned int x, unsigned int y)
    {
    if (x>=MX | y>=MY) return(0);
    return(vmem[x+y*MX]);
    }

void mvid::doblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
    {
    if ((x+mx)>MX | (y+my)>MY) return;
    unsigned int xx,yy;

        #ifdef DOS
        unsigned myds=_my_ds();
        unsigned mfrom=(unsigned)v;
        unsigned mto=(unsigned)vmem+x+(y*MX);
    for (yy=0; yy<my; yy++)
        {
        movedata(myds,mfrom, myds, mto, mx);
        from+=mx;
        to+=MX;
        }
        #else
    for (yy=0; yy<my; yy++)
        for (xx=0; xx<mx; xx++)
            vmem[(xx+x)+(yy+y)*MX]=v[xx+yy*mx];
        #endif
    }


void mvid::idoblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
    {
    if ((x+mx)>MX | (y+my)>MY) return;
    unsigned int xx,yy;
    long mfrom,mto;
    for (yy=0; yy<my; yy++)
        {
        mfrom=yy*mx;
        mto=((yy+y)*MX)+x;
        for (xx=0; xx<mx; xx++)
            {
            if (v[mfrom]!=CLEAR_COLOR)
                vmem[mto]=v[mfrom];
            mfrom++;
            mto++;
            }
        }
    }



void mvid::getblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)

    {
    if ((x+mx)>MX | (y+my)>MY) return;
    unsigned int xx,yy;
    for (yy=0; yy<my; yy++)
        #ifdef DOS
        movedata(_my_ds(), (unsigned)vmem+x+((y+yy)*MX), _my_ds(), (unsigned)v+(yy*mx), mx);
        #else
        for (xx=0; xx<mx; xx++)
            v[xx+yy*mx]=vmem[(xx+x)+(yy+y)*MX];
        #endif
    }

unsigned char *mvid::getmpointer(void)
    {
    return(vmem);
    }

/*
void mvid::domvid(mvid *mv, unsigned int x, unsigned int y)
    {
    doblock(mv->getmpointer(),x,y,mv->MX,mv->MY);
    }
  */
